package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class FileReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 1;
	private final SkeletonPackrat basePackrat_;
	public FileReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeFile(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 1);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeFile(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub_1(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 0).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_5(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_1(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_4(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_2(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_3(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isOUTPUT_KEYWORD()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 2).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 3).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int itemSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 10).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(3, rule);
		return newOffset;
	}
	public final int itemSub_5(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 6).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(4, rule);
		return newOffset;
	}
}
