package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class JavaInstanceVariableReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 63;
	private final SkeletonPackrat basePackrat_;
	public JavaInstanceVariableReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeJavaInstanceVariable(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 63);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeJavaInstanceVariable(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 25).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		result.mark();
		int checkOffset_2 = maybeSub_1(result, c, newOffset);
		if(checkOffset_2 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_2;
			result.removeLastMark();
		}
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(4, token);
		result.mark();
		int checkOffset_3 = maybeSub_2(result, c, newOffset);
		if(checkOffset_3 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_3;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_4 = maybeSub_3(result, c, newOffset);
		if(checkOffset_4 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_4;
			result.removeLastMark();
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_1(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isPUBLIC_KEYWORD()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isPRIVATE_KEYWORD()) {
			return -1;
		}
		result.addSubToken(1, token);
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_2(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_3(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isFINAL_KEYWORD()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSTATIC_KEYWORD()) {
			return -1;
		}
		result.addSubToken(3, token);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 18).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int maybeSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 31).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int maybeSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(3, rule);
		return newOffset;
	}
}
