package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class JavaMacroBlockReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 14;
	private final SkeletonPackrat basePackrat_;
	public JavaMacroBlockReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeJavaMacroBlock(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 14);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeJavaMacroBlock(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isMACRO_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_5 = c.getColumnToken(newOffset);
		if(!token_5.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 68).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 15).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
}
