package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
public final class JavaMethodCallReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 28;
	private final SkeletonPackrat basePackrat_;
	public JavaMethodCallReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeJavaMethodCall(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 28);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeJavaMethodCall(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_2);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 29).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
}
