package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class JavaStatementReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 22;
	private final SkeletonPackrat basePackrat_;
	public JavaStatementReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeBlockForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeDeclarationForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeIfForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeNoteForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeForForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 4, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeWhileForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 5, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMarkForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 6, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMacroCallForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 7, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeExpressionVarForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 8, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeStatementVarForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 9, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeFindForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 10, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeLinkBlockForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 11, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeReturnSimpleForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 12, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeReturnForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 13, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeThrowForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 14, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeExpressionForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 15, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeSyncForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 16, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeSetForJavaStatement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 17, 22);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeBlockForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 20).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeDeclarationForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 25).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token);
		result.mark();
		int checkOffset_1 = maybeSub_1(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_1;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_2 = maybeSub_2(result, c, newOffset);
		if(checkOffset_2 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_2;
			result.removeLastMark();
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isFINAL_KEYWORD()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 31).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int maybeSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int decodeIfForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isIF_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 22).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		result.mark();
		int checkOffset = maybeSub_3(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int maybeSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isELSE_KEYWORD()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int decodeNoteForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isNOTE_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSTRING()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_2);
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeForForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isFOR_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = maybeSub_4(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset_1 = maybeSub_5(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_1;
			result.removeLastMark();
		}
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset_2 = maybeSub_6(result, c, newOffset);
		if(checkOffset_2 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_2;
			result.removeLastMark();
		}
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(3, rule);
		return newOffset;
	}
	public final int maybeSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 21).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int maybeSub_5(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int maybeSub_6(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int decodeWhileForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isWHILE_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 22).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeMarkForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isMARK_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeMacroCallForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 23).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeExpressionVarForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isEXPRESSION_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeStatementVarForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSTATEMENT_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeFindForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 53).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeLinkBlockForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLINK_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_2 = itemSub_3(result, c, newOffset);
			if(checkOffset_2 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_2;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 34).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_1(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_2(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_CURLY()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub_1(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int decodeReturnSimpleForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isRETURN_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeReturnForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isRETURN_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeThrowForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isTHROW_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeExpressionForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeSyncForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSYNCHRONIZED_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_4(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_5(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub_2(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int itemSub_5(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int decodeSetForJavaStatement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSET_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_2);
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
