package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class MacroElementReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 15;
	private final SkeletonPackrat basePackrat_;
	public MacroElementReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeArgValsBlockForMacroElement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 15);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeArgTypesBlockForMacroElement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 15);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeCodeBlockForMacroElement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 15);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeContextBlockForMacroElement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 15);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeContainerBlockForMacroElement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 4, 15);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeArgValsBlockForMacroElement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 46).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeArgTypesBlockForMacroElement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 47).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeCodeBlockForMacroElement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isCODE_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		int checkOffset_2 = newOffset;
		result.mark();
		while(checkOffset_2 >= 0) {
			checkOffset_2 = zeroOrMoreSub_1(result, c, newOffset);
			if(checkOffset_2 > newOffset) {
				newOffset = checkOffset_2;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		int checkOffset_3 = newOffset;
		result.mark();
		while(checkOffset_3 >= 0) {
			checkOffset_3 = zeroOrMoreSub_2(result, c, newOffset);
			if(checkOffset_3 > newOffset) {
				newOffset = checkOffset_3;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		result.addSubToken(1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 47).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 22).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 46).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int decodeContextBlockForMacroElement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSKELETON_CLASS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		result.mark();
		int checkOffset = maybeSub_1(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub_3(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		result.addSubToken(1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 19).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeContainerBlockForMacroElement(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isCONTAINER_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub_4(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 19).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
}
