package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
public final class MacroParameterBlockReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 68;
	private final SkeletonPackrat basePackrat_;
	public MacroParameterBlockReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeMacroParameterBlock(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 68);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeMacroParameterBlock(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 38).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
