package org.ffd2.skeletonx.austenx.peg.base;
public final class FindTargetPeer {
	public static interface Indirect {
		public FindTargetPeer.VariableBasedPatternPeer createVariableBased(java.lang.String childName, int childNameLine, int childNameCharacter) ;
		public FindTargetPeer.RootBasedPatternPeer createRootBased() ;
		public void createLocalBased(java.lang.String childName, int childNameLine, int childNameCharacter) ;
		public void createSimpleThreadBased(java.lang.String nodeLayerName, int nodeLayerNameLine, int nodeLayerNameCharacter, java.lang.String childName, int childNameLine, int childNameCharacter) ;
		public FindTargetPeer.BackThreadBasedPatternPeer createBackThreadBased(java.lang.String nodeLayerName, int nodeLayerNameLine, int nodeLayerNameCharacter, java.lang.String childName, int childNameLine, int childNameCharacter) ;
		public FindTargetPeer.ThreadBasedPatternPeer createThreadBased(java.lang.String nodeLayerName, int nodeLayerNameLine, int nodeLayerNameCharacter, java.lang.String childName, int childNameLine, int childNameCharacter) ;
	}
	public static interface VariableBasedPatternPeer {
		public void end() ;
		public void addVariableName(java.lang.String value, int lineNumber, int characterNumber) ;
	}
	public static interface RootBasedPatternPeer {
		public void end() ;
		public DesignTypePatternPeer addDesignTypeForResultType() ;
	}
	public static interface BackThreadBasedPatternPeer {
		public void end() ;
		public BuilderVariableChainPatternPeer addBuilderVariableChainForVariableChain() ;
	}
	public static interface ThreadBasedPatternPeer {
		public void end() ;
		public void addVariableName(java.lang.String value, int lineNumber, int characterNumber) ;
	}
}
