package org.ffd2.skeletonx.compile.design;

import org.ffd2.skeletonx.compile.impl.ChainDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.TemplateRootBlock;
import org.ffd2.solar.exceptions.ItemNotFoundException;
import org.ffd2.solar.exceptions.ParsingException;

public interface DesignTypeAccess {
  public DesignType getDesignType(String name) throws ItemNotFoundException;
  public TemplateRootBlock getTemplate(String name) throws ParsingException;
  public ChainDefinitionBlock getChain(String name) throws ParsingException;
	public MappingDefinitionBlock getMapping(String name) throws ParsingException;
	public KeyDefinitionBlock getKey(String name) throws ParsingException;

}
