package org.ffd2.skeletonx.compile.impl;

import org.ffd2.skeletonx.compile.design.DesignType;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock;
import org.ffd2.solar.exceptions.ParsingException;

public interface DesignVariable {
	
	/**
	 * Request a record from this variable 
	 * @param recordType type of variable requested
	 * @param fixedSkeleton the skeleton to update with the value
	 * @param variablePath the path from the fixed skeleton to the definition of this variable
	 */
	public void requestRecordFromVariableFinal(DesignType recordType, IsFixedDataBlock fixedSkeleton, BaseTrackers.DesignVariablePath variablePath) throws ParsingException;
	
}
