package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers;

public interface MacroCallRequirementsAccess {
	public void accessCodeReference(MacroCallDataBlock macroCallBlock);
	public BaseTrackers.JavaVariablePath buildPathToSLayer(SLayer targetLayer);
	public void accessContextReference(MacroCallDataBlock macroCallBlock);
	public void accessGeneralReference(MacroCallDataBlock macroCallBlock);

	public void addTargetVarRequirement(String name, TargetType varType, MacroCallDataBlock macroCallBlock);
	public void addRecordVarRequirement(String name, FoundationNode varType, MacroCallDataBlock macroCallBlock);
	
	public void addStringRequirement(String name,  MacroCallDataBlock macroCallBlock);
	public void addIntRequirement(String name,  MacroCallDataBlock macroCallBlock);
	public void addGeneralExpressionTargetRequirement(String name,TargetType requiredVarType, MacroCallDataBlock macroCallBlock);
	public void addCodeReferenceRequirement(String name, MacroCallDataBlock macroCallBlock);
	public void addArgValuesMarkRequirement(String name, MacroCallDataBlock macroCallBlock);
	public void addArgTypesMarkRequirement(String name, MacroCallDataBlock macroCallBlock);
	public void addMappingRequirement(String name, MappingDefinitionBlock type, MacroCallDataBlock macroCallBlock);
	public void addKeyRequirement(String name, KeyDefinitionBlock type, MacroCallDataBlock macroCallBlock);

}
