package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BaseTrackers;

public class Utils {
	public static final BaseTrackers.JavaVariablePath buildGeneralRecordRefParameter(SLayer subLevelRecord, SLayer parentRecord) {
		BaseTrackers.JavaVariablePath result = new BaseTrackers.JavaVariablePath();
		subLevelRecord.buildPathToUpperLayer(parentRecord, result);
		return result;
	}
	public static final BaseTrackers.JavaVariablePath buildPathToTargetTypeDeclaration(SLayer environment, TargetType targetType) {
		BaseTrackers.JavaVariablePath result = new BaseTrackers.JavaVariablePath();
		environment.buildPathToType(targetType, result,true);
		return result;
	}
}
