package org.ffd2.skeletonx.skeleton;
public final class BaseTrackers {
	public static final class DesignVariablePath {
		private BaseTrackers.DesignVariablePath.Link linksEnd_ = null;
		private int count_ = 0;
		public DesignVariablePath() {
		}
		public final void addToChain(org.ffd2.bones.base.CallChain target) {
			if(linksEnd_ != null) {
				linksEnd_.addLinkToChain(target);
			}
		}
		public final java.lang.String toString() {
			return count_ + ":" + linksEnd_;
		}
		public final boolean isSameMark(int pathMark) {
			return pathMark == count_;
		}
		public final boolean isEmpty() {
			return linksEnd_ == null;
		}
		public final void clear() {
			linksEnd_ = null;
			count_ = 0;
		}
		public final BaseTrackers.DesignVariablePath getCopy() {
			BaseTrackers.DesignVariablePath copy = new BaseTrackers.DesignVariablePath();
			transferTo(copy);
			return copy;
		}
		public final void transferTo(BaseTrackers.DesignVariablePath target) {
			if(linksEnd_ != null) {
				linksEnd_.transferTo(target);
			}
		}
		public final int mark() {
			return count_;
		}
		public final void unmark(int mark) {
			if(linksEnd_ != null) {
				linksEnd_ = linksEnd_.getMarked(mark - 1);
				count_ = mark;
			}
		}
		public final org.ffd2.bones.base.CallChain createChain() {
			org.ffd2.bones.base.CallChain result = new org.ffd2.bones.base.CallChain();
			if(linksEnd_ != null) {
				linksEnd_.addLinkToChain(result);
			}
			return result;
		}
		public final void addBlockParent(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.DesignVariablePath.BlockParentLink(toAdd, count_++, linksEnd_);
		}
		public static interface Link {
			public BaseTrackers.DesignVariablePath.Link getMarked(int index) ;
			public void transferTo(BaseTrackers.DesignVariablePath target) ;
			public void addLinkToChain(org.ffd2.bones.base.CallChain result) ;
			public java.lang.String toString() ;
		}
		public static final class BlockParentLink implements BaseTrackers.DesignVariablePath.Link {
			private final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.DesignVariablePath.Link previous_;
			public BlockParentLink(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock toAdd, int count, BaseTrackers.DesignVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "blockParent" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.DesignVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.DesignVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addBlockParent(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addBlockParentConnection(result);
			}
		}
	}
	public static final class JavaVariablePath {
		private BaseTrackers.JavaVariablePath.Link linksEnd_ = null;
		private int count_ = 0;
		public JavaVariablePath() {
		}
		public final void addToChain(org.ffd2.bones.base.CallChain target) {
			if(linksEnd_ != null) {
				linksEnd_.addLinkToChain(target);
			}
		}
		public final java.lang.String toString() {
			return count_ + ":" + linksEnd_;
		}
		public final boolean isSameMark(int pathMark) {
			return pathMark == count_;
		}
		public final boolean isEmpty() {
			return linksEnd_ == null;
		}
		public final void clear() {
			linksEnd_ = null;
			count_ = 0;
		}
		public final BaseTrackers.JavaVariablePath getCopy() {
			BaseTrackers.JavaVariablePath copy = new BaseTrackers.JavaVariablePath();
			transferTo(copy);
			return copy;
		}
		public final void transferTo(BaseTrackers.JavaVariablePath target) {
			if(linksEnd_ != null) {
				linksEnd_.transferTo(target);
			}
		}
		public final int mark() {
			return count_;
		}
		public final void unmark(int mark) {
			if(linksEnd_ != null) {
				linksEnd_ = linksEnd_.getMarked(mark - 1);
				count_ = mark;
			}
		}
		public final org.ffd2.bones.base.CallChain createChain() {
			org.ffd2.bones.base.CallChain result = new org.ffd2.bones.base.CallChain();
			if(linksEnd_ != null) {
				linksEnd_.addLinkToChain(result);
			}
			return result;
		}
		public final void addGeneralBlockVariable(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.GeneralBlockVariableLink(toAdd, count_++, linksEnd_);
		}
		public final void addLocalGlobalPeer(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsLocalDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.LocalGlobalPeerLink(toAdd, count_++, linksEnd_);
		}
		public final void addFoundVariable(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.FoundVariableLink(toAdd, count_++, linksEnd_);
		}
		public final void addBlockVariable(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.BlockVariableLink(toAdd, count_++, linksEnd_);
		}
		public final void addLocalParent(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsLocalDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.LocalParentLink(toAdd, count_++, linksEnd_);
		}
		public final void addDefiningLayerPeer(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.DefiningLayerPeerLink(toAdd, count_++, linksEnd_);
		}
		public final void addBlockParent(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock.IsChildDataBlock toAdd) {
			linksEnd_ = new BaseTrackers.JavaVariablePath.BlockParentLink(toAdd, count_++, linksEnd_);
		}
		public static interface Link {
			public BaseTrackers.JavaVariablePath.Link getMarked(int index) ;
			public void transferTo(BaseTrackers.JavaVariablePath target) ;
			public void addLinkToChain(org.ffd2.bones.base.CallChain result) ;
			public java.lang.String toString() ;
		}
		public static final class GeneralBlockVariableLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public GeneralBlockVariableLink(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "generalBlockVariable" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addGeneralBlockVariable(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addGeneralBlockVariableConnection(result);
			}
		}
		public static final class LocalGlobalPeerLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsLocalDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public LocalGlobalPeerLink(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsLocalDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "localGlobalPeer" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addLocalGlobalPeer(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addLocalGlobalPeerConnection(result);
			}
		}
		public static final class FoundVariableLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public FoundVariableLink(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "foundVariable" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addFoundVariable(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addFoundVariableConnection(result);
			}
		}
		public static final class BlockVariableLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public BlockVariableLink(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "blockVariable" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addBlockVariable(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addBlockVariableConnection(result);
			}
		}
		public static final class LocalParentLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsLocalDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public LocalParentLink(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsLocalDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "localParent" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addLocalParent(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addLocalParentConnection(result);
			}
		}
		public static final class DefiningLayerPeerLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public DefiningLayerPeerLink(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsMacroDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "definingLayerPeer" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addDefiningLayerPeer(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addDefiningLayerPeerConnection(result);
			}
		}
		public static final class BlockParentLink implements BaseTrackers.JavaVariablePath.Link {
			private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock.IsChildDataBlock toAdd_;
			private final int count_;
			private final BaseTrackers.JavaVariablePath.Link previous_;
			public BlockParentLink(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock.IsChildDataBlock toAdd, int count, BaseTrackers.JavaVariablePath.Link previous) {
				toAdd_ = toAdd;
				count_ = count;
				previous_ = previous;
			}
			public final java.lang.String toString() {
				java.lang.String base = "blockParent" + ":" + toAdd_;
				if(previous_ == null) {
					return base;
				} else {
					return previous_.toString() + base;
				}
			}
			public final BaseTrackers.JavaVariablePath.Link getMarked(int index) {
				if(index == count_) {
					return this;
				}
				if(previous_ == null) {
					return null;
				}
				return previous_.getMarked(index);
			}
			public final void transferTo(BaseTrackers.JavaVariablePath target) {
				if(previous_ != null) {
					previous_.transferTo(target);
				}
				target.addBlockParent(toAdd_);
			}
			public final void addLinkToChain(org.ffd2.bones.base.CallChain result) {
				if(previous_ != null) {
					previous_.addLinkToChain(result);
				}
				toAdd_.addBlockParentConnection(result);
			}
		}
	}
}
