package org.ffd2.skeletonx.skeleton;
public final class DesignArgumentValuesFormHolder {
	public static final class DesignArgumentValuesFormBlock {
		private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock previous_;
		public BaseBuilder parent_;
		public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock argumentValueEnd_ = null;
		public DesignArgumentValuesFormBlock(BaseBuilder parent, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock previous) {
			previous_ = previous;
			parent_ = parent;
		}
		public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(argumentValueEnd_ != null) {
				argumentValueEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(argumentValueEnd_ != null) {
				argumentValueEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getArgumentValueEnd() {
			return argumentValueEnd_;
		}
		public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock addArgumentValue() {
			DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock(this, argumentValueEnd_);
			argumentValueEnd_ = child;
			return child;
		}
		public static final class ArgumentValueDataBlock {
			private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock previous_;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock parent_;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock intEnd_ = null;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock booleanEnd_ = null;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock intArrayEnd_ = null;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock stringEnd_ = null;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock doubleEnd_ = null;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock recordValueEnd_ = null;
			public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock mappingValueEnd_ = null;
			public ArgumentValueDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock parent, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock previous) {
				previous_ = previous;
				parent_ = parent;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(intEnd_ != null) {
					intEnd_.resolutionPass(packageAccess);
				}
				if(booleanEnd_ != null) {
					booleanEnd_.resolutionPass(packageAccess);
				}
				if(intArrayEnd_ != null) {
					intArrayEnd_.resolutionPass(packageAccess);
				}
				if(stringEnd_ != null) {
					stringEnd_.resolutionPass(packageAccess);
				}
				if(doubleEnd_ != null) {
					doubleEnd_.resolutionPass(packageAccess);
				}
				if(recordValueEnd_ != null) {
					recordValueEnd_.resolutionPass(packageAccess);
				}
				if(mappingValueEnd_ != null) {
					mappingValueEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(intEnd_ != null) {
					intEnd_.finish();
				}
				if(booleanEnd_ != null) {
					booleanEnd_.finish();
				}
				if(intArrayEnd_ != null) {
					intArrayEnd_.finish();
				}
				if(stringEnd_ != null) {
					stringEnd_.finish();
				}
				if(doubleEnd_ != null) {
					doubleEnd_.finish();
				}
				if(recordValueEnd_ != null) {
					recordValueEnd_.finish();
				}
				if(mappingValueEnd_ != null) {
					mappingValueEnd_.finish();
				}
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock getParent() {
				return parent_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock getIntEnd() {
				return intEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock addInt(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock(this, valueSource, variablePath, intEnd_);
				intEnd_ = child;
				return child;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock getBooleanEnd() {
				return booleanEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock addBoolean(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock(this, valueSource, variablePath, booleanEnd_);
				booleanEnd_ = child;
				return child;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock getIntArrayEnd() {
				return intArrayEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock addIntArray(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock(this, valueSource, variablePath, intArrayEnd_);
				intArrayEnd_ = child;
				return child;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock getStringEnd() {
				return stringEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock addString(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock(this, valueSource, variablePath, stringEnd_);
				stringEnd_ = child;
				return child;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock getDoubleEnd() {
				return doubleEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock addDouble(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock(this, valueSource, variablePath, doubleEnd_);
				doubleEnd_ = child;
				return child;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock getRecordValueEnd() {
				return recordValueEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock addRecordValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock(this, valueSource, variablePath, recordValueEnd_);
				recordValueEnd_ = child;
				return child;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock getMappingValueEnd() {
				return mappingValueEnd_;
			}
			public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock addMappingValue(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath) {
				DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock child = new DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock(this, valueSource, variablePath, mappingValueEnd_);
				mappingValueEnd_ = child;
				return child;
			}
			public static final class IntDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public IntDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
			public static final class BooleanDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public BooleanDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.BooleanDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
			public static final class IntArrayDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public IntArrayDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.IntArrayDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
			public static final class StringDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public StringDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.StringDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
			public static final class DoubleDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public DoubleDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.DoubleDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
			public static final class RecordValueDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public RecordValueDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.RecordValueDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
			public static final class MappingValueDataBlock {
				private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock previous_;
				public DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent_;
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock valueSourceParameter_;
				private final BaseTrackers.DesignVariablePath variablePathParameter_;
				public MappingValueDataBlock(DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock valueSource, BaseTrackers.DesignVariablePath variablePath, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock previous) {
					previous_ = previous;
					valueSourceParameter_ = valueSource;
					variablePathParameter_ = variablePath;
					parent_ = parent;
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock.MappingValueDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock.ArgumentValueDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getValueSourceParameter() {
					return valueSourceParameter_;
				}
				public final BaseTrackers.DesignVariablePath getVariablePathParameter() {
					return variablePathParameter_;
				}
			}
		}
	}
}
