package org.ffd2.skeletonx.skeleton;
public final class TargetBaseFormHolder {
	public static final class TargetBaseFormBlock {
		private final TargetBaseFormHolder.TargetBaseFormBlock previous_;
		public BaseBuilder parent_;
		public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock blockEnd_ = null;
		public TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock chainEnd_ = null;
		private final java.lang.String nameParameter_;
		private org.ffd2.bones.base.BClass targetBaseBonesClass_;
		public TargetBaseFormBlock(BaseBuilder parent, java.lang.String name, TargetBaseFormHolder.TargetBaseFormBlock previous) {
			previous_ = previous;
			nameParameter_ = name;
			parent_ = parent;
			targetBaseBonesClass_ = new org.ffd2.bones.base.BClass(false);
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			packageAccess.addType(targetBaseBonesClass_);
			targetBaseBonesClass_.setName(this.getNameParameter(), "TargetBase");
			if(blockEnd_ != null) {
				blockEnd_.resolutionPass(packageAccess);
			}
			if(chainEnd_ != null) {
				chainEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(blockEnd_ != null) {
				blockEnd_.finish();
			}
			if(chainEnd_ != null) {
				chainEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getBlockEnd() {
			return blockEnd_;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock addBlock(java.lang.String name, int index, ParameterSettingsFormHolder.ParameterSettingsFormBlock parameters) {
			TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock child = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock(this, name, index, parameters, blockEnd_);
			blockEnd_ = child;
			return child;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock getChainEnd() {
			return chainEnd_;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock addChain(java.lang.String name, int index) {
			TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock child = new TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock(this, name, index, chainEnd_);
			chainEnd_ = child;
			return child;
		}
		public final java.lang.String getNameParameter() {
			return nameParameter_;
		}
		public final org.ffd2.bones.base.BClass getTargetBaseBonesClass() {
			return targetBaseBonesClass_;
		}
		public static final class BlockDataBlock {
			private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock previous_;
			public TargetBaseFormHolder.TargetBaseFormBlock parent_;
			private final org.ffd2.bones.base.BParameters parametersAnchor_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__1_;
			public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock isRootEnd_ = null;
			public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock childRefEnd_ = null;
			public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parameter3End_ = null;
			private final java.lang.String nameParameter_;
			private final int indexParameter_;
			private final ParameterSettingsFormHolder.ParameterSettingsFormBlock parametersParameter_;
			private org.ffd2.bones.base.BClass targetInterfaceBonesClass_;
			private final org.ffd2.bones.base.ParameterVariable indexBones_;
			private final org.ffd2.bones.base.ParameterVariable doOutputBones_;
			private final org.ffd2.bones.base.ParameterVariable indexBones_1_;
			private org.ffd2.bones.base.BMethod createBlockMethod_;
			private org.ffd2.bones.base.BMethod getCreatedMethod_;
			public BlockDataBlock(TargetBaseFormHolder.TargetBaseFormBlock parent, java.lang.String name, int index, ParameterSettingsFormHolder.ParameterSettingsFormBlock parameters, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock previous) {
				previous_ = previous;
				nameParameter_ = name;
				indexParameter_ = index;
				parametersParameter_ = parameters;
				parent_ = parent;
				targetInterfaceBonesClass_ = new org.ffd2.bones.base.BClass(false);
				indexBones_ = new org.ffd2.bones.base.ParameterVariable();
				doOutputBones_ = new org.ffd2.bones.base.ParameterVariable();
				indexBones_1_ = new org.ffd2.bones.base.ParameterVariable();
				parametersAnchor_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__1_ = new org.ffd2.bones.base.BParameters();
				createBlockMethod_ = new org.ffd2.bones.base.BMethod();
				getCreatedMethod_ = new org.ffd2.bones.base.BMethod();
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				getParent().getTargetBaseBonesClass().addType(targetInterfaceBonesClass_);
				targetInterfaceBonesClass_.setName(this.getNameParameter(), "TargetInterface", java.lang.String.valueOf(this.getIndexParameter()));
				getParent().getTargetBaseBonesClass().addInstanceMethod(createBlockMethod_);
				org.ffd2.bones.base.BParameters parameters = createBlockMethod_.getParameters();
				parameters.addParameter(getIndexBonesVariable());
				parameters.addParameter(getDoOutputBonesVariable());
				parameters.setAnchor(this.getParametersAnchor());
				parameters.setAnchor(this.getParametersAnchor_1());
				getParent().getTargetBaseBonesClass().addInstanceMethod(getCreatedMethod_);
				org.ffd2.bones.base.BParameters parameters_1 = getCreatedMethod_.getParameters();
				parameters_1.addParameter(getIndexBonesVariable_1());
				if(isRootEnd_ != null) {
					isRootEnd_.resolutionPass(packageAccess);
				}
				if(childRefEnd_ != null) {
					childRefEnd_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock peerEnd = getParametersParameter().getParameterEnd();
				if(peerEnd != null) {
					parameter3End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock(this, peerEnd);
					parameter3End_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				indexBones_.setName("index");
				org.ffd2.bones.base.TypeSettable varableType = indexBones_.getTypeSettable();
				varableType.setIntResultType();
				doOutputBones_.setName("doOutput");
				org.ffd2.bones.base.TypeSettable varableType_1 = doOutputBones_.getTypeSettable();
				varableType_1.setBooleanResultType();
				indexBones_1_.setName("index");
				org.ffd2.bones.base.TypeSettable varableType_2 = indexBones_1_.getTypeSettable();
				varableType_2.setIntResultType();
				createBlockMethod_.setName("create", this.getNameParameter(), "Block", java.lang.String.valueOf(this.getIndexParameter()));
				org.ffd2.bones.base.TypeSettable returnType = createBlockMethod_.getReturnTypeSettable();
				returnType.setVoidResultType();
				getCreatedMethod_.setName("getCreated", this.getNameParameter(), "Block", java.lang.String.valueOf(this.getIndexParameter()));
				org.ffd2.bones.base.TypeSettable returnType_1 = getCreatedMethod_.getReturnTypeSettable();
				returnType_1.setResultType(this.getTargetInterfaceBonesClass());
				if(isRootEnd_ != null) {
					isRootEnd_.finish();
				}
				if(childRefEnd_ != null) {
					childRefEnd_.finish();
				}
				if(parameter3End_ != null) {
					parameter3End_.finish();
				}
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock getParent() {
				return parent_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor() {
				return parametersAnchor_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_1() {
				return parametersAnchor__1_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock getIsRootEnd() {
				return isRootEnd_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock addIsRoot() {
				TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock child = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock(this, isRootEnd_);
				isRootEnd_ = child;
				return child;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock getChildRefEnd() {
				return childRefEnd_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock addChildRef(java.lang.String childName) {
				TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock child = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock(this, childName, childRefEnd_);
				childRefEnd_ = child;
				return child;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParameter3End() {
				return parameter3End_;
			}
			public final java.lang.String getNameParameter() {
				return nameParameter_;
			}
			public final int getIndexParameter() {
				return indexParameter_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getParametersParameter() {
				return parametersParameter_;
			}
			public final org.ffd2.bones.base.BClass getTargetInterfaceBonesClass() {
				return targetInterfaceBonesClass_;
			}
			public final org.ffd2.bones.base.ParameterVariable getIndexBonesVariable() {
				return indexBones_;
			}
			public final org.ffd2.bones.base.ParameterVariable getDoOutputBonesVariable() {
				return doOutputBones_;
			}
			public final org.ffd2.bones.base.ParameterVariable getIndexBonesVariable_1() {
				return indexBones_1_;
			}
			public final org.ffd2.bones.base.BMethod getCreateBlockBonesMethod() {
				return createBlockMethod_;
			}
			public final org.ffd2.bones.base.BMethod getGetCreatedBonesMethod() {
				return getCreatedMethod_;
			}
			public static final class IsRootDataBlock {
				private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock previous_;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock parent_;
				private final org.ffd2.bones.base.ParameterVariable namespaceElementsBones_;
				public IsRootDataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock parent, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
					namespaceElementsBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.IsRootDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					namespaceElementsBones_.setName("namespaceElements");
					org.ffd2.bones.base.TypeSettable varableType = namespaceElementsBones_.getTypeSettable();
					varableType.setExternalType("java.lang.String");
					varableType.setArrayDimensions(1);
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_1();
					parameters.addParameter(getNamespaceElementsBonesVariable());
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getParent() {
					return parent_;
				}
				public final org.ffd2.bones.base.ParameterVariable getNamespaceElementsBonesVariable() {
					return namespaceElementsBones_;
				}
			}
			public static final class ChildRefDataBlock {
				private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock previous_;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock parent_;
				private final java.lang.String childNameParameter_;
				private final org.ffd2.bones.base.ParameterVariable countBones_;
				private final org.ffd2.bones.base.ParameterVariable childNumberBones_;
				private final org.ffd2.bones.base.ParameterVariable blockIndexBones_;
				private org.ffd2.bones.base.BMethod setChildCountMethod_;
				private org.ffd2.bones.base.BMethod setChildMethod_;
				public ChildRefDataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock parent, java.lang.String childName, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock previous) {
					previous_ = previous;
					childNameParameter_ = childName;
					parent_ = parent;
					countBones_ = new org.ffd2.bones.base.ParameterVariable();
					childNumberBones_ = new org.ffd2.bones.base.ParameterVariable();
					blockIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
					setChildCountMethod_ = new org.ffd2.bones.base.BMethod();
					setChildMethod_ = new org.ffd2.bones.base.BMethod();
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					getParent().getTargetInterfaceBonesClass().addInstanceMethod(setChildCountMethod_);
					org.ffd2.bones.base.BParameters parameters = setChildCountMethod_.getParameters();
					parameters.addParameter(getCountBonesVariable());
					getParent().getTargetInterfaceBonesClass().addInstanceMethod(setChildMethod_);
					org.ffd2.bones.base.BParameters parameters_1 = setChildMethod_.getParameters();
					parameters_1.addParameter(getChildNumberBonesVariable());
					parameters_1.addParameter(getBlockIndexBonesVariable());
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					countBones_.setName("count");
					org.ffd2.bones.base.TypeSettable varableType = countBones_.getTypeSettable();
					varableType.setIntResultType();
					childNumberBones_.setName("childNumber");
					org.ffd2.bones.base.TypeSettable varableType_1 = childNumberBones_.getTypeSettable();
					varableType_1.setIntResultType();
					blockIndexBones_.setName("blockIndex");
					org.ffd2.bones.base.TypeSettable varableType_2 = blockIndexBones_.getTypeSettable();
					varableType_2.setIntResultType();
					setChildCountMethod_.setName("set", this.getChildNameParameter(), "ChildCount");
					org.ffd2.bones.base.TypeSettable returnType = setChildCountMethod_.getReturnTypeSettable();
					returnType.setVoidResultType();
					setChildMethod_.setName("set", this.getChildNameParameter(), "Child");
					org.ffd2.bones.base.TypeSettable returnType_1 = setChildMethod_.getReturnTypeSettable();
					returnType_1.setVoidResultType();
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getParent() {
					return parent_;
				}
				public final java.lang.String getChildNameParameter() {
					return childNameParameter_;
				}
				public final org.ffd2.bones.base.ParameterVariable getCountBonesVariable() {
					return countBones_;
				}
				public final org.ffd2.bones.base.ParameterVariable getChildNumberBonesVariable() {
					return childNumberBones_;
				}
				public final org.ffd2.bones.base.ParameterVariable getBlockIndexBonesVariable() {
					return blockIndexBones_;
				}
				public final org.ffd2.bones.base.BMethod getSetChildCountBonesMethod() {
					return setChildCountMethod_;
				}
				public final org.ffd2.bones.base.BMethod getSetChildBonesMethod() {
					return setChildMethod_;
				}
			}
			public static final class Parameter3DataBlock {
				private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock previous_;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock peer_;
				private final org.ffd2.bones.base.BParameters parametersAnchor_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__1_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__2_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__3_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__4_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__5_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__6_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__7_;
				private final org.ffd2.bones.base.BParameters parametersAnchor__8_;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Int4DataBlock int4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.IntArray4DataBlock intArray4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Double4DataBlock double4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Boolean4DataBlock boolean4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.String4DataBlock string4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Record4DataBlock record4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Chain4DataBlock chain4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Mapping4DataBlock mapping4End_ = null;
				public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Key4DataBlock key4End_ = null;
				public Parameter3DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock(parent, previousPeer);
					}
					parametersAnchor_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__1_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__2_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__3_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__4_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__5_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__6_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__7_ = new org.ffd2.bones.base.BParameters();
					parametersAnchor__8_ = new org.ffd2.bones.base.BParameters();
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock peerEnd = getPeer().getIntEnd();
					if(peerEnd != null) {
						int4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Int4DataBlock(this, peerEnd);
						int4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock peerEnd_1 = getPeer().getIntArrayEnd();
					if(peerEnd_1 != null) {
						intArray4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.IntArray4DataBlock(this, peerEnd_1);
						intArray4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock peerEnd_2 = getPeer().getDoubleEnd();
					if(peerEnd_2 != null) {
						double4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Double4DataBlock(this, peerEnd_2);
						double4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock peerEnd_3 = getPeer().getBooleanEnd();
					if(peerEnd_3 != null) {
						boolean4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Boolean4DataBlock(this, peerEnd_3);
						boolean4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock peerEnd_4 = getPeer().getStringEnd();
					if(peerEnd_4 != null) {
						string4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.String4DataBlock(this, peerEnd_4);
						string4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock peerEnd_5 = getPeer().getRecordEnd();
					if(peerEnd_5 != null) {
						record4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Record4DataBlock(this, peerEnd_5);
						record4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock peerEnd_6 = getPeer().getChainEnd();
					if(peerEnd_6 != null) {
						chain4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Chain4DataBlock(this, peerEnd_6);
						chain4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock peerEnd_7 = getPeer().getMappingEnd();
					if(peerEnd_7 != null) {
						mapping4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Mapping4DataBlock(this, peerEnd_7);
						mapping4End_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock peerEnd_8 = getPeer().getKeyEnd();
					if(peerEnd_8 != null) {
						key4End_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Key4DataBlock(this, peerEnd_8);
						key4End_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor();
					parameters.setAnchor(this.getParametersAnchor());
					parameters.setAnchor(this.getParametersAnchor_1());
					parameters.setAnchor(this.getParametersAnchor_2());
					parameters.setAnchor(this.getParametersAnchor_3());
					parameters.setAnchor(this.getParametersAnchor_4());
					parameters.setAnchor(this.getParametersAnchor_5());
					parameters.setAnchor(this.getParametersAnchor_6());
					parameters.setAnchor(this.getParametersAnchor_7());
					parameters.setAnchor(this.getParametersAnchor_8());
					if(int4End_ != null) {
						int4End_.finish();
					}
					if(intArray4End_ != null) {
						intArray4End_.finish();
					}
					if(double4End_ != null) {
						double4End_.finish();
					}
					if(boolean4End_ != null) {
						boolean4End_.finish();
					}
					if(string4End_ != null) {
						string4End_.finish();
					}
					if(record4End_ != null) {
						record4End_.finish();
					}
					if(chain4End_ != null) {
						chain4End_.finish();
					}
					if(mapping4End_ != null) {
						mapping4End_.finish();
					}
					if(key4End_ != null) {
						key4End_.finish();
					}
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor() {
					return parametersAnchor_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_1() {
					return parametersAnchor__1_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_2() {
					return parametersAnchor__2_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_3() {
					return parametersAnchor__3_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_4() {
					return parametersAnchor__4_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_5() {
					return parametersAnchor__5_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_6() {
					return parametersAnchor__6_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_7() {
					return parametersAnchor__7_;
				}
				public final org.ffd2.bones.base.BParameters getParametersAnchor_8() {
					return parametersAnchor__8_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Int4DataBlock getInt4End() {
					return int4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.IntArray4DataBlock getIntArray4End() {
					return intArray4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Double4DataBlock getDouble4End() {
					return double4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Boolean4DataBlock getBoolean4End() {
					return boolean4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.String4DataBlock getString4End() {
					return string4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Record4DataBlock getRecord4End() {
					return record4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Chain4DataBlock getChain4End() {
					return chain4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Mapping4DataBlock getMapping4End() {
					return mapping4End_;
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Key4DataBlock getKey4End() {
					return key4End_;
				}
				public static final class Int4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Int4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
					public Int4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Int4DataBlock(parent, previousPeer);
						}
						parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Int4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
						org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
						varableType.setIntResultType();
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor();
						parameters.addParameter(getParameterValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
						return parameterValueBones_;
					}
				}
				public static final class IntArray4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.IntArray4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
					public IntArray4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.IntArray4DataBlock(parent, previousPeer);
						}
						parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.IntArray4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
						org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
						varableType.setIntResultType();
						varableType.setArrayDimensions(1);
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_1();
						parameters.addParameter(getParameterValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
						return parameterValueBones_;
					}
				}
				public static final class Double4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Double4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
					public Double4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Double4DataBlock(parent, previousPeer);
						}
						parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Double4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
						org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
						varableType.setDoubleResultType();
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_2();
						parameters.addParameter(getParameterValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
						return parameterValueBones_;
					}
				}
				public static final class Boolean4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Boolean4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
					public Boolean4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Boolean4DataBlock(parent, previousPeer);
						}
						parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Boolean4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
						org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
						varableType.setBooleanResultType();
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_3();
						parameters.addParameter(getParameterValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
						return parameterValueBones_;
					}
				}
				public static final class String4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.String4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
					public String4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.String4DataBlock(parent, previousPeer);
						}
						parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.String4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
						org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
						varableType.setExternalType("java.lang.String");
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_4();
						parameters.addParameter(getParameterValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
						return parameterValueBones_;
					}
				}
				public static final class Record4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Record4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable recordIndexBones_;
					public Record4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Record4DataBlock(parent, previousPeer);
						}
						recordIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Record4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						recordIndexBones_.setName(getPeer().getParent().getParameterNameParameter(), "RecordIndex");
						org.ffd2.bones.base.TypeSettable varableType = recordIndexBones_.getTypeSettable();
						varableType.setIntResultType();
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_5();
						parameters.addParameter(getRecordIndexBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getRecordIndexBonesVariable() {
						return recordIndexBones_;
					}
				}
				public static final class Chain4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Chain4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable chainIndexBones_;
					public Chain4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Chain4DataBlock(parent, previousPeer);
						}
						chainIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Chain4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						chainIndexBones_.setName(getPeer().getParent().getParameterNameParameter(), "ChainIndex");
						org.ffd2.bones.base.TypeSettable varableType = chainIndexBones_.getTypeSettable();
						varableType.setIntResultType();
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_6();
						parameters.addParameter(getChainIndexBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getChainIndexBonesVariable() {
						return chainIndexBones_;
					}
				}
				public static final class Mapping4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Mapping4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable mappingValueBones_;
					public Mapping4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Mapping4DataBlock(parent, previousPeer);
						}
						mappingValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Mapping4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						mappingValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Mapping");
						org.ffd2.bones.base.TypeSettable varableType = mappingValueBones_.getTypeSettable();
						varableType.setResultType(getPeer().getMappingParameter().getMappingInterfaceBonesClass());
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_7();
						parameters.addParameter(getMappingValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getMappingValueBonesVariable() {
						return mappingValueBones_;
					}
				}
				public static final class Key4DataBlock {
					private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Key4DataBlock previous_;
					public TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable keyValueBones_;
					public Key4DataBlock(TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Key4DataBlock(parent, previousPeer);
						}
						keyValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock.Key4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						keyValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Key");
						org.ffd2.bones.base.TypeSettable varableType = keyValueBones_.getTypeSettable();
						varableType.setResultType(getPeer().getKeyParameter().getKeyMarkerInterfaceBonesClass());
						org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_8();
						parameters.addParameter(getKeyValueBonesVariable());
					}
					public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.Parameter3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getKeyValueBonesVariable() {
						return keyValueBones_;
					}
				}
			}
		}
		public static final class ChainDataBlock {
			private final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock previous_;
			public TargetBaseFormHolder.TargetBaseFormBlock parent_;
			public TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock linkRefEnd_ = null;
			private final java.lang.String nameParameter_;
			private final int indexParameter_;
			private org.ffd2.bones.base.BClass chainInterfaceBonesClass_;
			private final org.ffd2.bones.base.ParameterVariable numberOfChainsBones_;
			private final org.ffd2.bones.base.ParameterVariable indexBones_;
			private org.ffd2.bones.base.BMethod createChainsMethod_;
			private org.ffd2.bones.base.BMethod getCreatedMethod_;
			public ChainDataBlock(TargetBaseFormHolder.TargetBaseFormBlock parent, java.lang.String name, int index, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock previous) {
				previous_ = previous;
				nameParameter_ = name;
				indexParameter_ = index;
				parent_ = parent;
				chainInterfaceBonesClass_ = new org.ffd2.bones.base.BClass(false);
				numberOfChainsBones_ = new org.ffd2.bones.base.ParameterVariable();
				indexBones_ = new org.ffd2.bones.base.ParameterVariable();
				createChainsMethod_ = new org.ffd2.bones.base.BMethod();
				getCreatedMethod_ = new org.ffd2.bones.base.BMethod();
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				getParent().getTargetBaseBonesClass().addType(chainInterfaceBonesClass_);
				chainInterfaceBonesClass_.setName(this.getNameParameter(), "ChainInterface", java.lang.String.valueOf(this.getIndexParameter()));
				getParent().getTargetBaseBonesClass().addInstanceMethod(createChainsMethod_);
				org.ffd2.bones.base.BParameters parameters = createChainsMethod_.getParameters();
				parameters.addParameter(getNumberOfChainsBonesVariable());
				getParent().getTargetBaseBonesClass().addInstanceMethod(getCreatedMethod_);
				org.ffd2.bones.base.BParameters parameters_1 = getCreatedMethod_.getParameters();
				parameters_1.addParameter(getIndexBonesVariable());
				if(linkRefEnd_ != null) {
					linkRefEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				numberOfChainsBones_.setName("numberOfChains");
				org.ffd2.bones.base.TypeSettable varableType = numberOfChainsBones_.getTypeSettable();
				varableType.setIntResultType();
				indexBones_.setName("index");
				org.ffd2.bones.base.TypeSettable varableType_1 = indexBones_.getTypeSettable();
				varableType_1.setIntResultType();
				createChainsMethod_.setName("create", this.getNameParameter(), "Chains", java.lang.String.valueOf(this.getIndexParameter()));
				org.ffd2.bones.base.TypeSettable returnType = createChainsMethod_.getReturnTypeSettable();
				returnType.setVoidResultType();
				getCreatedMethod_.setName("getCreated", this.getNameParameter(), "Chain", java.lang.String.valueOf(this.getIndexParameter()));
				org.ffd2.bones.base.TypeSettable returnType_1 = getCreatedMethod_.getReturnTypeSettable();
				returnType_1.setResultType(this.getChainInterfaceBonesClass());
				if(linkRefEnd_ != null) {
					linkRefEnd_.finish();
				}
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock getParent() {
				return parent_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock getLinkRefEnd() {
				return linkRefEnd_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock addLinkRef(java.lang.String linkName) {
				TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock child = new TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock(this, linkName, linkRefEnd_);
				linkRefEnd_ = child;
				return child;
			}
			public final java.lang.String getNameParameter() {
				return nameParameter_;
			}
			public final int getIndexParameter() {
				return indexParameter_;
			}
			public final org.ffd2.bones.base.BClass getChainInterfaceBonesClass() {
				return chainInterfaceBonesClass_;
			}
			public final org.ffd2.bones.base.ParameterVariable getNumberOfChainsBonesVariable() {
				return numberOfChainsBones_;
			}
			public final org.ffd2.bones.base.ParameterVariable getIndexBonesVariable() {
				return indexBones_;
			}
			public final org.ffd2.bones.base.BMethod getCreateChainsBonesMethod() {
				return createChainsMethod_;
			}
			public final org.ffd2.bones.base.BMethod getGetCreatedBonesMethod() {
				return getCreatedMethod_;
			}
			public static final class LinkRefDataBlock {
				private final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock previous_;
				public TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock parent_;
				private final java.lang.String linkNameParameter_;
				private final org.ffd2.bones.base.ParameterVariable linkIndexBones_;
				private final org.ffd2.bones.base.ParameterVariable blockIndexBones_;
				private org.ffd2.bones.base.BMethod addLinkMethod_;
				public LinkRefDataBlock(TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock parent, java.lang.String linkName, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock previous) {
					previous_ = previous;
					linkNameParameter_ = linkName;
					parent_ = parent;
					linkIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
					blockIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
					addLinkMethod_ = new org.ffd2.bones.base.BMethod();
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					getParent().getChainInterfaceBonesClass().addInstanceMethod(addLinkMethod_);
					org.ffd2.bones.base.BParameters parameters = addLinkMethod_.getParameters();
					parameters.addParameter(getLinkIndexBonesVariable());
					parameters.addParameter(getBlockIndexBonesVariable());
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					linkIndexBones_.setName("linkIndex");
					org.ffd2.bones.base.TypeSettable varableType = linkIndexBones_.getTypeSettable();
					varableType.setIntResultType();
					blockIndexBones_.setName("blockIndex");
					org.ffd2.bones.base.TypeSettable varableType_1 = blockIndexBones_.getTypeSettable();
					varableType_1.setIntResultType();
					addLinkMethod_.setName("add", this.getLinkNameParameter(), "Link");
					org.ffd2.bones.base.TypeSettable returnType = addLinkMethod_.getReturnTypeSettable();
					returnType.setVoidResultType();
				}
				public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock getParent() {
					return parent_;
				}
				public final java.lang.String getLinkNameParameter() {
					return linkNameParameter_;
				}
				public final org.ffd2.bones.base.ParameterVariable getLinkIndexBonesVariable() {
					return linkIndexBones_;
				}
				public final org.ffd2.bones.base.ParameterVariable getBlockIndexBonesVariable() {
					return blockIndexBones_;
				}
				public final org.ffd2.bones.base.BMethod getAddLinkBonesMethod() {
					return addLinkMethod_;
				}
			}
		}
	}
}
