package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class ArgValsBlockBaseReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 46;
	private final SkeletonPackrat basePackrat_;
	public ArgValsBlockBaseReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeArgValsBlockBase(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 46);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeArgValsBlockBase(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isARGVALS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_2);
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 29).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_5 = c.getColumnToken(newOffset);
		if(!token_5.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
