package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class FindTargetReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 54;
	private final SkeletonPackrat basePackrat_;
	public FindTargetReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeVariableBasedForFindTarget(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 54);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeRootBasedForFindTarget(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 54);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeLocalBasedForFindTarget(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 54);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeSimpleThreadBasedForFindTarget(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 54);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeBackThreadBasedForFindTarget(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 4, 54);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeThreadBasedForFindTarget(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 5, 54);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeVariableBasedForFindTarget(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isFROM_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		result.addSubToken(1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeRootBasedForFindTarget(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 44).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeLocalBasedForFindTarget(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isTHIS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_3);
		return newOffset;
	}
	public final int decodeSimpleThreadBasedForFindTarget(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_3);
		return newOffset;
	}
	public final int decodeBackThreadBasedForFindTarget(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 33).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_2);
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_4);
		return newOffset;
	}
	public final int decodeThreadBasedForFindTarget(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = dividedPrimarySub_1(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub_1(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub_1(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(2, token_4);
		return newOffset;
	}
	public final int dividedPrimarySub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		result.addSubToken(1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int dividedSecondarySub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
