package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class JavaExpressionReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 24;
	private final SkeletonPackrat basePackrat_;
	public JavaExpressionReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeBinaryForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 24);
			width = result.endRestrain(24, 0);
			return oldElement.getImprovedByOrNull(result, 0);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeGeneralBinaryForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 24);
			width = result.endRestrain(24, 1);
			return oldElement.getImprovedByOrNull(result, 1);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodePostUnaryForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 24);
			width = result.endRestrain(24, 2);
			return oldElement.getImprovedByOrNull(result, 2);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodePreUnaryForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 24);
			width = result.endRestrain(24, 3);
			return oldElement.getImprovedByOrNull(result, 3);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeAssignmentForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 4, 24);
			width = result.endRestrain(24, 4);
			return oldElement.getImprovedByOrNull(result, 4);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMappingVariableRefForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 5, 24);
			width = result.endRestrain(24, 5);
			return oldElement.getImprovedByOrNull(result, 5);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeCallForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 6, 24);
			width = result.endRestrain(24, 6);
			return oldElement.getImprovedByOrNull(result, 6);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeBracketedForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 7, 24);
			width = result.endRestrain(24, 7);
			return oldElement.getImprovedByOrNull(result, 7);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeBuilderVariableRefForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 8, 24);
			width = result.endRestrain(24, 8);
			return oldElement.getImprovedByOrNull(result, 8);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeArrayConstructorCallForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 9, 24);
			width = result.endRestrain(24, 9);
			return oldElement.getImprovedByOrNull(result, 9);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeGivenArrayForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 10, 24);
			width = result.endRestrain(24, 10);
			return oldElement.getImprovedByOrNull(result, 10);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeConstructorCallForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 11, 24);
			width = result.endRestrain(24, 11);
			return oldElement.getImprovedByOrNull(result, 11);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodePrimitiveForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 12, 24);
			width = result.endRestrain(24, 12);
			return oldElement.getImprovedByOrNull(result, 12);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeThisForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 13, 24);
			width = result.endRestrain(24, 13);
			return oldElement.getImprovedByOrNull(result, 13);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeNullForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 14, 24);
			width = result.endRestrain(24, 14);
			return oldElement.getImprovedByOrNull(result, 14);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMarkForJavaExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 15, 24);
			width = result.endRestrain(24, 15);
			return oldElement.getImprovedByOrNull(result, 15);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeBinaryForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 62).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_2 = c.getResult(newOffset, 24).getResolved();
		if(rule_2 == null) {
			return -1;
		}
		newOffset += rule_2.getWidth();
		result.addSubNode(2, rule_2);
		return newOffset;
	}
	public final int decodeGeneralBinaryForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isGENERAL_BINARY_START()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 24).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isGENERAL_BINARY_END()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_2 = c.getResult(newOffset, 24).getResolved();
		if(rule_2 == null) {
			return -1;
		}
		newOffset += rule_2.getWidth();
		result.addSubNode(2, rule_2);
		return newOffset;
	}
	public final int decodePostUnaryForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 62).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodePreUnaryForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 62).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 24).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeAssignmentForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 27).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 24).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		return newOffset;
	}
	public final int decodeMappingVariableRefForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 33).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_SQUARE()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 33).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_SQUARE()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int decodeCallForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 27).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeBracketedForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int decodeBuilderVariableRefForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 33).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeArrayConstructorCallForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isNEW_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 64).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		result.mark();
		int checkOffset = oneOrMoreSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset >= 0) {
				checkOffset = oneOrMoreSub(result, c, newOffset);
				if(checkOffset > newOffset) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int oneOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_SQUARE()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_SQUARE()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int decodeGivenArrayForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isNEW_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 64).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_CURLY()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule_1 = c.getResult(newOffset, 29).getResolved();
		if(rule_1 == null) {
			return -1;
		}
		newOffset += rule_1.getWidth();
		result.addSubNode(1, rule_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_CURLY()) {
			return -1;
		}
		result.addSubToken(-1, token_2);
		newOffset++;
		return newOffset;
	}
	public final int decodeConstructorCallForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isNEW_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 64).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isLEFT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isRIGHT_ROUND()) {
			return -1;
		}
		result.addSubToken(-1, token_2);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 29).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int decodePrimitiveForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_5(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_1(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_4(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_2(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_3(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCHAR()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isSTRING()) {
			return -1;
		}
		result.addSubToken(1, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isINTEGER()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_5(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isBOOLEAN_VALUE()) {
			return -1;
		}
		result.addSubToken(3, token);
		newOffset++;
		return newOffset;
	}
	public final int decodeThisForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isTHIS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		return newOffset;
	}
	public final int decodeNullForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isNULL_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		return newOffset;
	}
	public final int decodeMarkForJavaExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isMARK_KEYWORD()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		return newOffset;
	}
}
