package org.ffd2.skeletonx.austenx.peg.base;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class DeferredJavaStatementImpl implements DeferredJavaStatement {
	private final org.ffd2.austenx.runtime.ResolvedPackratElement myElement_;
	public DeferredJavaStatementImpl(org.ffd2.austenx.runtime.ResolvedPackratElement myElement) {
		myElement_ = myElement;
	}
	public final void buildJavaStatement(JavaStatementPeer.Indirect target) {
		final org.ffd2.austenx.runtime.ResolvedPackratElement element = myElement_;
		int type = element.getType();
		if(type == 0) {
			JavaStatementPeer.BlockPatternPeer child = target.createBlock();
			if(child != null) {
				element.updateConstruction(new AllDecodersSkeleton.BlockDecoder_1(child));
				child.end();
			}
		}
		if(type == 1) {
			org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
			JavaStatementPeer.DeclarationPatternPeer child_1 = target.createDeclaration(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
			if(child_1 != null) {
				element.updateConstruction(new AllDecodersSkeleton.DeclarationDecoder_1(child_1));
				child_1.end();
			}
		}
		if(type == 2) {
			org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
			JavaStatementPeer.IfPatternPeer child_2 = target.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
			if(child_2 != null) {
				element.updateConstruction(new AllDecodersSkeleton.IfDecoder_1(child_2));
				child_2.end();
			}
		}
		if(type == 3) {
			org.ffd2.austenx.runtime.BaseToken noteToken = element.getBaseArgumentToken(0);
			target.createNote(noteToken.getStringValue());
		}
		if(type == 4) {
			org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
			JavaStatementPeer.ForPatternPeer child_3 = target.createFor(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
			if(child_3 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ForDecoder(child_3));
				child_3.end();
			}
		}
		if(type == 5) {
			org.ffd2.austenx.runtime.BaseToken keywordToken_2 = element.getBaseArgumentToken(0);
			JavaStatementPeer.WhilePatternPeer child_4 = target.createWhile(keywordToken_2.getLineNumber(), keywordToken_2.getCharacterNumber());
			if(child_4 != null) {
				element.updateConstruction(new AllDecodersSkeleton.WhileDecoder(child_4));
				child_4.end();
			}
		}
		if(type == 6) {
			org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
			target.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
		}
		if(type == 7) {
			JavaStatementPeer.MacroCallPatternPeer child_5 = target.createMacroCall();
			if(child_5 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_2(child_5));
				child_5.end();
			}
		}
		if(type == 8) {
			org.ffd2.austenx.runtime.BaseToken variableNameToken = element.getBaseArgumentToken(0);
			JavaStatementPeer.ExpressionVarPatternPeer child_6 = target.createExpressionVar(variableNameToken.getStringValue(), variableNameToken.getLineNumber(), variableNameToken.getCharacterNumber());
			if(child_6 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ExpressionVarDecoder(child_6));
				child_6.end();
			}
		}
		if(type == 9) {
			org.ffd2.austenx.runtime.BaseToken variableNameToken_1 = element.getBaseArgumentToken(0);
			JavaStatementPeer.StatementVarPatternPeer child_7 = target.createStatementVar(variableNameToken_1.getStringValue(), variableNameToken_1.getLineNumber(), variableNameToken_1.getCharacterNumber());
			if(child_7 != null) {
				element.updateConstruction(new AllDecodersSkeleton.StatementVarDecoder(child_7));
				child_7.end();
			}
		}
		if(type == 10) {
			JavaStatementPeer.FindPatternPeer child_8 = target.createFind();
			if(child_8 != null) {
				element.updateConstruction(new AllDecodersSkeleton.FindDecoder_2(child_8));
				child_8.end();
			}
		}
		if(type == 11) {
			JavaStatementPeer.LinkBlockPatternPeer child_9 = target.createLinkBlock();
			if(child_9 != null) {
				element.updateConstruction(new AllDecodersSkeleton.LinkBlockDecoder(child_9));
				child_9.end();
			}
		}
		if(type == 12) {
			org.ffd2.austenx.runtime.BaseToken keywordToken_3 = element.getBaseArgumentToken(0);
			target.createReturnSimple(keywordToken_3.getLineNumber(), keywordToken_3.getCharacterNumber());
		}
		if(type == 13) {
			org.ffd2.austenx.runtime.BaseToken keywordToken_4 = element.getBaseArgumentToken(0);
			JavaStatementPeer.ReturnPatternPeer child_10 = target.createReturn(keywordToken_4.getLineNumber(), keywordToken_4.getCharacterNumber());
			if(child_10 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ReturnDecoder(child_10));
				child_10.end();
			}
		}
		if(type == 14) {
			org.ffd2.austenx.runtime.BaseToken keywordToken_5 = element.getBaseArgumentToken(0);
			JavaStatementPeer.ThrowPatternPeer child_11 = target.createThrow(keywordToken_5.getLineNumber(), keywordToken_5.getCharacterNumber());
			if(child_11 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ThrowDecoder(child_11));
				child_11.end();
			}
		}
		if(type == 15) {
			JavaStatementPeer.ExpressionPatternPeer child_12 = target.createExpression();
			if(child_12 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ExpressionDecoder_1(child_12));
				child_12.end();
			}
		}
		if(type == 16) {
			org.ffd2.austenx.runtime.BaseToken keywordToken_6 = element.getBaseArgumentToken(0);
			JavaStatementPeer.SyncPatternPeer child_13 = target.createSync(keywordToken_6.getLineNumber(), keywordToken_6.getCharacterNumber());
			if(child_13 != null) {
				element.updateConstruction(new AllDecodersSkeleton.SyncDecoder(child_13));
				child_13.end();
			}
		}
		if(type == 17) {
			org.ffd2.austenx.runtime.BaseToken variableNameToken_2 = element.getBaseArgumentToken(0);
			JavaStatementPeer.SetPatternPeer child_14 = target.createSet(variableNameToken_2.getStringValue(), variableNameToken_2.getLineNumber(), variableNameToken_2.getCharacterNumber());
			if(child_14 != null) {
				element.updateConstruction(new AllDecodersSkeleton.SetDecoder(child_14));
				child_14.end();
			}
		}
	}
}
