package org.ffd2.skeletonx.compile.impl;


public interface ChainImplementationTarget {
	/**
	 * Tell the implementation to include the described line for this chain
	 * @param linkName the name of link
	 * @param linkIndex the "index" (eg order)
	 * @param blockIndex the block index (the index of the link's type)
	 */
	public void addLink(String linkName, int linkIndex, int blockIndex) ;
}
