package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.austenx.peg.base.GeneralSymbolPatternPeer;

public class GeneralSymbolBlock implements GeneralSymbolPatternPeer {
	private String symbol_ = null;
	public GeneralSymbolBlock() { }
	public String getSymbol() {
		return this.symbol_;
	}
	
	public void addMinus() { this.symbol_ = "-"; }
	public void addPlus() { this.symbol_ = "+"; }
	public void addStar() {this.symbol_ = "*";  }
	public void addSlash() { this.symbol_ = "/"; }
	//Might want to do an error for unary stuff...
	public void addGreaterThan(int lineNumber, int characterNumber) { this.symbol_ = ">"; }
	public void addLessThan(int lineNumber, int characterNumber) { this.symbol_ = "<"; }
	public void end() {
	}
	public void addOther(String value) {
		this.symbol_ = value;
	}
	public void addExclamationMark(){ this.symbol_ = "!"; }


}
