/**
 * 
 */
package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.ChainDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.DesignBridgeComponents.DesignRecordReference;
import org.ffd2.skeletonx.compile.impl.KeyDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;

public interface ImplementationParameterTarget {
  public void newIntParameter(String name);
  public void newIntArrayParameter(String name);
  public void newStringParameter(String name);
  public void newBooleanParameter(String name);
  public void newDoubleParameter(String name);
  public void newRecordParameter(String name, DesignRecordReference reference); 
  
  public void newChainParameter(String name, ChainDefinitionBlock definition);
  public void newMappingParameter(String name, MappingDefinitionBlock definition);
  public void newKeyParameter(String name, KeyDefinitionBlock definition);
  public void allParametersDeclared();
}