package org.ffd2.skeletonx.compile.java;


public class SGlobalMethodReferenceHolder {
	 private final GlobalMethodReference method_;
	 private SGlobalMethodReferenceHolder next_;
	 private final GlobalClassReference targetType_;

	 public SGlobalMethodReferenceHolder(GlobalClassReference targetType,  GlobalMethodReference method, SGlobalMethodReferenceHolder next) {
	   this.targetType_ = targetType;
	   this.method_ = method;
	   this.next_ = next;
	 }
	 public boolean isContains(TargetType queryTargetType) {
	   if(this.targetType_ == queryTargetType) {
	     return true;
	   } else if(next_==null) {
	     return false;
	   } else {
	     return next_.isContains(queryTargetType);
	   }
	 }
	 public GlobalMethodReference getMethod(TargetType queryTargetType) {
	   if(this.targetType_ == queryTargetType) {
	     return this.method_;
	   } else if(next_==null) {
	     return null;
	   } else {
	     return next_.getMethod(queryTargetType);
	   }
	 }

}
