package org.ffd2.skeletonx.compile.java;


public class SVariableHolder {
	 private final TargetVariable variable_;
	 private SVariableHolder next_;
	 private final TargetType targetType_;

	 public SVariableHolder(TargetType targetType,  TargetVariable variable, SVariableHolder next) {
	   this.targetType_ = targetType;
	   this.variable_ = variable;
	   this.next_ = next;
	 }
	 public boolean isContains(TargetType queryTargetType) {
	   if(this.targetType_ == queryTargetType) {
	     return true;
	   } else if(next_==null) {
	     return false;
	   } else {
	     return next_.isContains(queryTargetType);
	   }
	 }
	 public TargetVariable getVariable(TargetType queryTargetType) {
	   if(this.targetType_ == queryTargetType) {
	     return this.variable_;
	   } else if(next_==null) {
	     return null;
	   } else {
	     return next_.getVariable(queryTargetType);
	   }
	 }

}
