package org.ffd2.skeletonx.skeleton;
public final class BasicCallChainFormHolder {
	public static final class BasicCallChainFormBlock {
		private final BasicCallChainFormHolder.BasicCallChainFormBlock previous_;
		public BaseBuilder parent_;
		public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock elementEnd_ = null;
		public BasicCallChainFormBlock(BaseBuilder parent, BasicCallChainFormHolder.BasicCallChainFormBlock previous) {
			previous_ = previous;
			parent_ = parent;
		}
		public final BasicCallChainFormHolder.BasicCallChainFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(elementEnd_ != null) {
				elementEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(elementEnd_ != null) {
				elementEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getElementEnd() {
			return elementEnd_;
		}
		public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock addElement() {
			BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock(this, elementEnd_);
			elementEnd_ = child;
			return child;
		}
		public static final class ElementDataBlock {
			private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock previous_;
			public BasicCallChainFormHolder.BasicCallChainFormBlock parent_;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock staticCallEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock variableEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock methodEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock externalVariableEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock externalMethodEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock chainParameterEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock generalChainParameterEnd_ = null;
			public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock dividerEnd_ = null;
			public ElementDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock parent, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock previous) {
				previous_ = previous;
				parent_ = parent;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(staticCallEnd_ != null) {
					staticCallEnd_.resolutionPass(packageAccess);
				}
				if(variableEnd_ != null) {
					variableEnd_.resolutionPass(packageAccess);
				}
				if(methodEnd_ != null) {
					methodEnd_.resolutionPass(packageAccess);
				}
				if(externalVariableEnd_ != null) {
					externalVariableEnd_.resolutionPass(packageAccess);
				}
				if(externalMethodEnd_ != null) {
					externalMethodEnd_.resolutionPass(packageAccess);
				}
				if(chainParameterEnd_ != null) {
					chainParameterEnd_.resolutionPass(packageAccess);
				}
				if(generalChainParameterEnd_ != null) {
					generalChainParameterEnd_.resolutionPass(packageAccess);
				}
				if(dividerEnd_ != null) {
					dividerEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(staticCallEnd_ != null) {
					staticCallEnd_.finish();
				}
				if(variableEnd_ != null) {
					variableEnd_.finish();
				}
				if(methodEnd_ != null) {
					methodEnd_.finish();
				}
				if(externalVariableEnd_ != null) {
					externalVariableEnd_.finish();
				}
				if(externalMethodEnd_ != null) {
					externalMethodEnd_.finish();
				}
				if(chainParameterEnd_ != null) {
					chainParameterEnd_.finish();
				}
				if(generalChainParameterEnd_ != null) {
					generalChainParameterEnd_.finish();
				}
				if(dividerEnd_ != null) {
					dividerEnd_.finish();
				}
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock getParent() {
				return parent_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock getStaticCallEnd() {
				return staticCallEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock addStaticCall(TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock typeDetails) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock(this, typeDetails, staticCallEnd_);
				staticCallEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock getVariableEnd() {
				return variableEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock addVariable(CodeVariableFormHolder.CodeVariableFormBlock target, BaseTrackers.JavaVariablePath recordPath) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock(this, target, recordPath, variableEnd_);
				variableEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock getMethodEnd() {
				return methodEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock addMethod(CodeMethodFormHolder.CodeMethodFormBlock target, BaseTrackers.JavaVariablePath recordPath, ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock methodArgumentDetails) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock(this, target, recordPath, methodArgumentDetails, methodEnd_);
				methodEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock getExternalVariableEnd() {
				return externalVariableEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock addExternalVariable(java.lang.String variableName) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock(this, variableName, externalVariableEnd_);
				externalVariableEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock getExternalMethodEnd() {
				return externalMethodEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock addExternalMethod(java.lang.String methodName, ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock methodArgumentDetails) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock(this, methodName, methodArgumentDetails, externalMethodEnd_);
				externalMethodEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock getChainParameterEnd() {
				return chainParameterEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock addChainParameter(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock chainParameter, BaseTrackers.JavaVariablePath recordPath) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock(this, chainParameter, recordPath, chainParameterEnd_);
				chainParameterEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock getGeneralChainParameterEnd() {
				return generalChainParameterEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock addGeneralChainParameter(CallChainStoreFormHolder.CallChainStoreFormBlock chainParameter, BaseTrackers.JavaVariablePath recordPath) {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock(this, chainParameter, recordPath, generalChainParameterEnd_);
				generalChainParameterEnd_ = child;
				return child;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock getDividerEnd() {
				return dividerEnd_;
			}
			public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock addDivider() {
				BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock child = new BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock(this, dividerEnd_);
				dividerEnd_ = child;
				return child;
			}
			public static final class StaticCallDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock typeDetailsParameter_;
				public StaticCallDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock typeDetails, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock previous) {
					previous_ = previous;
					typeDetailsParameter_ = typeDetails;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.StaticCallDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock getTypeDetailsParameter() {
					return typeDetailsParameter_;
				}
			}
			public static final class VariableDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final CodeVariableFormHolder.CodeVariableFormBlock targetParameter_;
				private final BaseTrackers.JavaVariablePath recordPathParameter_;
				public VariableDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, CodeVariableFormHolder.CodeVariableFormBlock target, BaseTrackers.JavaVariablePath recordPath, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock previous) {
					previous_ = previous;
					targetParameter_ = target;
					recordPathParameter_ = recordPath;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.VariableDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final CodeVariableFormHolder.CodeVariableFormBlock getTargetParameter() {
					return targetParameter_;
				}
				public final BaseTrackers.JavaVariablePath getRecordPathParameter() {
					return recordPathParameter_;
				}
			}
			public static final class MethodDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final CodeMethodFormHolder.CodeMethodFormBlock targetParameter_;
				private final BaseTrackers.JavaVariablePath recordPathParameter_;
				private final ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock methodArgumentDetailsParameter_;
				public MethodDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, CodeMethodFormHolder.CodeMethodFormBlock target, BaseTrackers.JavaVariablePath recordPath, ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock methodArgumentDetails, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock previous) {
					previous_ = previous;
					targetParameter_ = target;
					recordPathParameter_ = recordPath;
					methodArgumentDetailsParameter_ = methodArgumentDetails;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.MethodDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final CodeMethodFormHolder.CodeMethodFormBlock getTargetParameter() {
					return targetParameter_;
				}
				public final BaseTrackers.JavaVariablePath getRecordPathParameter() {
					return recordPathParameter_;
				}
				public final ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock getMethodArgumentDetailsParameter() {
					return methodArgumentDetailsParameter_;
				}
			}
			public static final class ExternalVariableDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final java.lang.String variableNameParameter_;
				public ExternalVariableDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, java.lang.String variableName, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock previous) {
					previous_ = previous;
					variableNameParameter_ = variableName;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalVariableDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final java.lang.String getVariableNameParameter() {
					return variableNameParameter_;
				}
			}
			public static final class ExternalMethodDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final java.lang.String methodNameParameter_;
				private final ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock methodArgumentDetailsParameter_;
				public ExternalMethodDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, java.lang.String methodName, ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock methodArgumentDetails, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock previous) {
					previous_ = previous;
					methodNameParameter_ = methodName;
					methodArgumentDetailsParameter_ = methodArgumentDetails;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ExternalMethodDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final java.lang.String getMethodNameParameter() {
					return methodNameParameter_;
				}
				public final ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock getMethodArgumentDetailsParameter() {
					return methodArgumentDetailsParameter_;
				}
			}
			public static final class ChainParameterDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock chainParameterParameter_;
				private final BaseTrackers.JavaVariablePath recordPathParameter_;
				public ChainParameterDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock chainParameter, BaseTrackers.JavaVariablePath recordPath, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock previous) {
					previous_ = previous;
					chainParameterParameter_ = chainParameter;
					recordPathParameter_ = recordPath;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.ChainParameterDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock getChainParameterParameter() {
					return chainParameterParameter_;
				}
				public final BaseTrackers.JavaVariablePath getRecordPathParameter() {
					return recordPathParameter_;
				}
			}
			public static final class GeneralChainParameterDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				private final CallChainStoreFormHolder.CallChainStoreFormBlock chainParameterParameter_;
				private final BaseTrackers.JavaVariablePath recordPathParameter_;
				public GeneralChainParameterDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, CallChainStoreFormHolder.CallChainStoreFormBlock chainParameter, BaseTrackers.JavaVariablePath recordPath, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock previous) {
					previous_ = previous;
					chainParameterParameter_ = chainParameter;
					recordPathParameter_ = recordPath;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.GeneralChainParameterDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
				public final CallChainStoreFormHolder.CallChainStoreFormBlock getChainParameterParameter() {
					return chainParameterParameter_;
				}
				public final BaseTrackers.JavaVariablePath getRecordPathParameter() {
					return recordPathParameter_;
				}
			}
			public static final class DividerDataBlock {
				private final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock previous_;
				public BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent_;
				public DividerDataBlock(BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock parent, BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock.DividerDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final BasicCallChainFormHolder.BasicCallChainFormBlock.ElementDataBlock getParent() {
					return parent_;
				}
			}
		}
	}
}
