package org.ffd2.skeletonx.skeleton;
public final class DesignFormHolder {
	public static final class DesignFormBlock {
		private final DesignFormHolder.DesignFormBlock previous_;
		public BaseBuilder parent_;
		private BaseBuilder.DataBlockBuilderMacroBlock relatedDataBlockMacroInstance_;
		private final org.ffd2.bones.base.ArgumentSet argumentsAnchor_;
		private final org.ffd2.bones.base.BParameters parametersAnchor_;
		public DesignFormHolder.DesignFormBlock.ChainDataBlock chainEnd_ = null;
		public DesignFormHolder.DesignFormBlock.TemplateDataBlock templateEnd_ = null;
		public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parameter2End_ = null;
		private final java.lang.String nameParameter_;
		private final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock relatedTrackerParameter_;
		private final ParameterSettingsFormHolder.ParameterSettingsFormBlock parametersParameter_;
		private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock targetPeerParameter_;
		private final DataBlockFormHolder.DataBlockFormBlock rootBlockDetailsParameter_;
		private org.ffd2.bones.base.BClass designRootBonesClass_;
		private org.ffd2.bones.base.InstanceVariable baseBlocks_Bones_;
		private org.ffd2.bones.base.InstanceVariable idTracker_Bones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration resultBones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration numberOfBlocksBones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration buildIndexBones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration finaliseIndexBones_;
		private final org.ffd2.bones.base.ParameterVariable idTrackerBones_;
		private final org.ffd2.bones.base.ParameterVariable initialDoOutputBones_;
		private final org.ffd2.bones.base.ParameterVariable namespaceElementsBones_;
		private final org.ffd2.bones.base.ParameterVariable targetBones_;
		private final org.ffd2.bones.base.BCodeBlock constructorCode_;
		private final org.ffd2.bones.base.BCodeBlock constructorCode__1_;
		private final org.ffd2.bones.base.BCodeBlock constructSimpleCode_;
		private final org.ffd2.bones.base.BCodeBlock addDataBlockCode_;
		private final org.ffd2.bones.base.BCodeBlock buildCode_;
		private final org.ffd2.bones.base.BCodeBlock buildCode__1_;
		private final org.ffd2.bones.base.BCodeBlock buildCode__2_;
		private org.ffd2.bones.base.BMethod constructSimpleMethod_;
		private org.ffd2.bones.base.BMethod addDataBlockMethod_;
		private org.ffd2.bones.base.BMethod buildMethod_;
		private final org.ffd2.bones.base.BClassStore inlineContainerAnchor_;
		private final org.ffd2.bones.base.BConstructor bonesConstructor_;
		public DesignFormBlock(BaseBuilder parent, java.lang.String name, IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock relatedTracker, ParameterSettingsFormHolder.ParameterSettingsFormBlock parameters, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock targetPeer, DataBlockFormHolder.DataBlockFormBlock rootBlockDetails, DesignFormHolder.DesignFormBlock previous) {
			previous_ = previous;
			inlineContainerAnchor_ = new org.ffd2.bones.base.BClassStore();
			nameParameter_ = name;
			relatedTrackerParameter_ = relatedTracker;
			parametersParameter_ = parameters;
			targetPeerParameter_ = targetPeer;
			rootBlockDetailsParameter_ = rootBlockDetails;
			parent_ = parent;
			designRootBonesClass_ = new org.ffd2.bones.base.BClass(true);
			baseBlocks_Bones_ = new org.ffd2.bones.base.InstanceVariable();
			idTracker_Bones_ = new org.ffd2.bones.base.InstanceVariable();
			resultBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			numberOfBlocksBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			buildIndexBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			finaliseIndexBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			idTrackerBones_ = new org.ffd2.bones.base.ParameterVariable();
			initialDoOutputBones_ = new org.ffd2.bones.base.ParameterVariable();
			namespaceElementsBones_ = new org.ffd2.bones.base.ParameterVariable();
			targetBones_ = new org.ffd2.bones.base.ParameterVariable();
			constructorCode_ = new org.ffd2.bones.base.BCodeBlock();
			constructorCode__1_ = new org.ffd2.bones.base.BCodeBlock();
			constructSimpleCode_ = new org.ffd2.bones.base.BCodeBlock();
			addDataBlockCode_ = new org.ffd2.bones.base.BCodeBlock();
			buildCode_ = new org.ffd2.bones.base.BCodeBlock();
			buildCode__1_ = new org.ffd2.bones.base.BCodeBlock();
			buildCode__2_ = new org.ffd2.bones.base.BCodeBlock();
			argumentsAnchor_ = new org.ffd2.bones.base.ArgumentSet();
			parametersAnchor_ = new org.ffd2.bones.base.BParameters();
			constructSimpleMethod_ = new org.ffd2.bones.base.BMethod();
			constructSimpleMethod_.setCodeBlock(getConstructSimpleCode());
			addDataBlockMethod_ = new org.ffd2.bones.base.BMethod();
			addDataBlockMethod_.setCodeBlock(getAddDataBlockCode());
			buildMethod_ = new org.ffd2.bones.base.BMethod();
			buildMethod_.setCodeBlock(getBuildCode());
			bonesConstructor_ = new org.ffd2.bones.base.BConstructor();
			bonesConstructor_.setCodeBlock(getConstructorCode());
			bonesConstructor_.setPublic();
			relatedDataBlockMacroInstance_ = getParent().createDataBlockBuilderMacro(this.getInlineAnchor(), this.getRootBlockDetailsParameter());
		}
		public final DesignFormHolder.DesignFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			packageAccess.addType(designRootBonesClass_);
			designRootBonesClass_.setName(this.getNameParameter(), "DesignRoot");
			this.getDesignRootBonesClass().addInstanceVariable(baseBlocks_Bones_);
			baseBlocks_Bones_.setName("baseBlocks_");
			this.getDesignRootBonesClass().addInstanceVariable(idTracker_Bones_);
			idTracker_Bones_.setName("idTracker_");
			this.getDesignRootBonesClass().addInstanceMethod(constructSimpleMethod_);
			org.ffd2.bones.base.BParameters parameters = constructSimpleMethod_.getParameters();
			this.getDesignRootBonesClass().addInstanceMethod(addDataBlockMethod_);
			org.ffd2.bones.base.BParameters parameters_1 = addDataBlockMethod_.getParameters();
			parameters_1.addParameter(getInitialDoOutputBonesVariable());
			parameters_1.setAnchor(this.getParametersAnchor());
			parameters_1.addParameter(getNamespaceElementsBonesVariable());
			this.getDesignRootBonesClass().addInstanceMethod(buildMethod_);
			org.ffd2.bones.base.BParameters parameters_2 = buildMethod_.getParameters();
			parameters_2.addParameter(getTargetBonesVariable());
			this.getDesignRootBonesClass().addConstructor(bonesConstructor_);
			org.ffd2.bones.base.BParameters parameters_3 = bonesConstructor_.getParameters();
			parameters_3.addParameter(getIdTrackerBonesVariable());
			relatedDataBlockMacroInstance_.resolutionPass(packageAccess);
			if(chainEnd_ != null) {
				chainEnd_.resolutionPass(packageAccess);
			}
			if(templateEnd_ != null) {
				templateEnd_.resolutionPass(packageAccess);
			}
			ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock peerEnd = getParametersParameter().getParameterEnd();
			if(peerEnd != null) {
				parameter2End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock(this, peerEnd);
				parameter2End_.resolutionPass(packageAccess);
			}
			packageAccess.addClassStore(inlineContainerAnchor_);
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			resultBones_.setName("result");
			org.ffd2.bones.base.TypeSettable varableType = resultBones_.getTypeSettable();
			varableType.setResultType(getRootBlockDetailsParameter().getDataClassBonesClass());
			numberOfBlocksBones_.setName("numberOfBlocks");
			org.ffd2.bones.base.TypeSettable varableType_1 = numberOfBlocksBones_.getTypeSettable();
			varableType_1.setIntResultType();
			buildIndexBones_.setName("buildIndex");
			org.ffd2.bones.base.TypeSettable varableType_2 = buildIndexBones_.getTypeSettable();
			varableType_2.setIntResultType();
			finaliseIndexBones_.setName("finaliseIndex");
			org.ffd2.bones.base.TypeSettable varableType_3 = finaliseIndexBones_.getTypeSettable();
			varableType_3.setIntResultType();
			idTrackerBones_.setName("idTracker");
			org.ffd2.bones.base.TypeSettable varableType_4 = idTrackerBones_.getTypeSettable();
			varableType_4.setResultType(getRelatedTrackerParameter().getParent().getIDTrackerBonesClass());
			initialDoOutputBones_.setName("initialDoOutput");
			org.ffd2.bones.base.TypeSettable varableType_5 = initialDoOutputBones_.getTypeSettable();
			varableType_5.setBooleanResultType();
			namespaceElementsBones_.setName("namespaceElements");
			org.ffd2.bones.base.TypeSettable varableType_6 = namespaceElementsBones_.getTypeSettable();
			varableType_6.setExternalType("java.lang.String");
			varableType_6.setArrayDimensions(1);
			targetBones_.setName("target");
			org.ffd2.bones.base.TypeSettable varableType_7 = targetBones_.getTypeSettable();
			varableType_7.setResultType(getTargetPeerParameter().getParent().getTargetBaseBonesClass());
			constructSimpleMethod_.setName("constructSimple");
			org.ffd2.bones.base.TypeSettable returnType = constructSimpleMethod_.getReturnTypeSettable();
			returnType.setResultType(this.getDesignRootBonesClass());
			constructSimpleMethod_.setStatic();
			constructSimpleMethod_.setFinal();
			addDataBlockMethod_.setName("addDataBlock");
			org.ffd2.bones.base.TypeSettable returnType_1 = addDataBlockMethod_.getReturnTypeSettable();
			returnType_1.setResultType(getRootBlockDetailsParameter().getDataClassBonesClass());
			buildMethod_.setName("build");
			org.ffd2.bones.base.TypeSettable returnType_2 = buildMethod_.getReturnTypeSettable();
			returnType_2.setVoidResultType();
			org.ffd2.bones.base.TypeSettable varableType_8 = baseBlocks_Bones_.getTypeSettable();
			varableType_8.setExternalType("org.ffd2.solar.general.SimpleVector");
			org.ffd2.bones.base.TypeSettable genericTarget = varableType_8.addGenerics();
			genericTarget.setResultType(getRootBlockDetailsParameter().getDataClassBonesClass());
			org.ffd2.bones.base.TypeSettable varableType_9 = idTracker_Bones_.getTypeSettable();
			varableType_9.setResultType(getRelatedTrackerParameter().getParent().getIDTrackerBonesClass());
			org.ffd2.bones.base.BCodeBlock target = getConstructSimpleCode();
			org.ffd2.bones.base.BExpression returnValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BConstructorCall constructorCall = returnValue.constructorCall();
			org.ffd2.bones.base.TypeSettable targetType = constructorCall.getTypeSettable();
			targetType.setResultType(this.getDesignRootBonesClass());
			org.ffd2.bones.base.ArgumentSet constructorArguments = constructorCall.getArgumentSet();
			org.ffd2.bones.base.BExpression argument = constructorArguments.addNewArgument();
			org.ffd2.bones.base.BConstructorCall constructorCall_1 = argument.constructorCall();
			org.ffd2.bones.base.TypeSettable targetType_1 = constructorCall_1.getTypeSettable();
			targetType_1.setResultType(getRelatedTrackerParameter().getParent().getIDTrackerBonesClass());
			target.addReturn(returnValue);
			org.ffd2.bones.base.BCodeBlock target_1 = getAddDataBlockCode();
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable = this.getResultBonesVariable();
			target_1.addDeclareVariable(declarationVariable);
			org.ffd2.bones.base.BExpression initialValueExpression = declarationVariable.createValue();
			org.ffd2.bones.base.BConstructorCall constructorCall_2 = initialValueExpression.constructorCall();
			org.ffd2.bones.base.TypeSettable targetType_2 = constructorCall_2.getTypeSettable();
			targetType_2.setResultType(getRootBlockDetailsParameter().getDataClassBonesClass());
			org.ffd2.bones.base.ArgumentSet constructorArguments_1 = constructorCall_2.getArgumentSet();
			org.ffd2.bones.base.BExpression argument_1 = constructorArguments_1.addNewArgument();
			argument_1.variable(this.getInitialDoOutputBonesVariable());
			org.ffd2.bones.base.BExpression argument_2 = constructorArguments_1.addNewArgument();
			argument_2.variable(this.getIdTracker_BonesVariable());
			constructorArguments_1.anchor(this.getArgumentsAnchor());
			org.ffd2.bones.base.BExpression argument_3 = constructorArguments_1.addNewArgument();
			argument_3.variable(this.getNamespaceElementsBonesVariable());
			org.ffd2.bones.base.BExpression argument_4 = constructorArguments_1.addNewArgument();
			argument_4.setThis();
			org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
			chain.chainVariable(this.getBaseBlocks_BonesVariable());
			expressionValue.callChain(chain);
			org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("addElement");
			org.ffd2.bones.base.BExpression argument_5 = methodArguments.addNewArgument();
			argument_5.variable(this.getResultBonesVariable());
			expressionValue.callChain(chain_1);
			target_1.addExpression(expressionValue);
			org.ffd2.bones.base.BExpression returnValue_1 = new org.ffd2.bones.base.BExpression();
			returnValue_1.variable(this.getResultBonesVariable());
			target_1.addReturn(returnValue_1);
			org.ffd2.bones.base.BCodeBlock target_2 = getBuildCode();
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_1 = this.getNumberOfBlocksBonesVariable();
			target_2.addDeclareVariable(declarationVariable_1);
			org.ffd2.bones.base.BExpression initialValueExpression_1 = declarationVariable_1.createValue();
			org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
			chain_2.chainVariable(this.getBaseBlocks_BonesVariable());
			initialValueExpression_1.callChain(chain_2);
			org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments_1 = chain_3.externalMethodCall("size");
			initialValueExpression_1.callChain(chain_3);
			org.ffd2.bones.base.ForBlock forBlock = target_2.forBlock();
			org.ffd2.bones.base.BExpression conditionalExpression = forBlock.getTerminateConditional();
			org.ffd2.bones.base.BExpression roundExpression = forBlock.getLoopConditional();
			org.ffd2.bones.base.BExpression right = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left = new org.ffd2.bones.base.BExpression();
			left.variable(this.getBuildIndexBonesVariable());
			right.variable(this.getNumberOfBlocksBonesVariable());
			conditionalExpression.binary(left, "<", right);
			org.ffd2.bones.base.BExpression unary = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression unary_1 = new org.ffd2.bones.base.BExpression();
			unary_1.variable(this.getBuildIndexBonesVariable());
			unary.postUnary(unary_1, "+");
			roundExpression.postUnary(unary, "+");
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_2 = this.getBuildIndexBonesVariable();
			forBlock.addInitialVariable(declarationVariable_2);
			org.ffd2.bones.base.BExpression initialValueExpression_2 = declarationVariable_2.createValue();
			initialValueExpression_2.primitiveInt(0);
			org.ffd2.bones.base.BCodeBlock loopBlock = forBlock.getMainCode();
			buildFor(loopBlock);
			target_2.insertCode(getBuildCode_1());
			org.ffd2.bones.base.ForBlock forBlock_1 = target_2.forBlock();
			org.ffd2.bones.base.BExpression conditionalExpression_1 = forBlock_1.getTerminateConditional();
			org.ffd2.bones.base.BExpression roundExpression_1 = forBlock_1.getLoopConditional();
			org.ffd2.bones.base.BExpression right_1 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left_1 = new org.ffd2.bones.base.BExpression();
			left_1.variable(this.getFinaliseIndexBonesVariable());
			right_1.variable(this.getNumberOfBlocksBonesVariable());
			conditionalExpression_1.binary(left_1, "<", right_1);
			org.ffd2.bones.base.BExpression unary_2 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression unary_3 = new org.ffd2.bones.base.BExpression();
			unary_3.variable(this.getFinaliseIndexBonesVariable());
			unary_2.postUnary(unary_3, "+");
			roundExpression_1.postUnary(unary_2, "+");
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_3 = this.getFinaliseIndexBonesVariable();
			forBlock_1.addInitialVariable(declarationVariable_3);
			org.ffd2.bones.base.BExpression initialValueExpression_3 = declarationVariable_3.createValue();
			initialValueExpression_3.primitiveInt(0);
			org.ffd2.bones.base.BCodeBlock loopBlock_1 = forBlock_1.getMainCode();
			buildFor_1(loopBlock_1);
			target_2.insertCode(getBuildCode_2());
			org.ffd2.bones.base.BCodeBlock target_3 = getConstructorCode();
			org.ffd2.bones.base.BExpression expressionValue_1 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression right_2 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left_2 = new org.ffd2.bones.base.BExpression();
			left_2.variable(this.getIdTracker_BonesVariable());
			right_2.variable(this.getIdTrackerBonesVariable());
			expressionValue_1.binary(left_2, "=", right_2);
			target_3.addExpression(expressionValue_1);
			org.ffd2.bones.base.BExpression expressionValue_2 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression right_3 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left_3 = new org.ffd2.bones.base.BExpression();
			left_3.variable(this.getBaseBlocks_BonesVariable());
			org.ffd2.bones.base.BConstructorCall constructorCall_3 = right_3.constructorCall();
			org.ffd2.bones.base.TypeSettable targetType_3 = constructorCall_3.getTypeSettable();
			targetType_3.setExternalType("org.ffd2.solar.general.SimpleVector");
			org.ffd2.bones.base.TypeSettable genericTarget_1 = targetType_3.addGenerics();
			genericTarget_1.setResultType(getRootBlockDetailsParameter().getDataClassBonesClass());
			expressionValue_2.binary(left_3, "=", right_3);
			target_3.addExpression(expressionValue_2);
			target_3.insertCode(getConstructorCode_1());
			relatedDataBlockMacroInstance_.finish();
			if(chainEnd_ != null) {
				chainEnd_.finish();
			}
			if(templateEnd_ != null) {
				templateEnd_.finish();
			}
			if(parameter2End_ != null) {
				parameter2End_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final BaseBuilder.DataBlockBuilderMacroBlock getRelatedDataBlockMacroInstance() {
			return relatedDataBlockMacroInstance_;
		}
		public final BaseBuilder.DataBlockBuilderMacroBlock getRelatedDataBlockMacro() {
			return relatedDataBlockMacroInstance_;
		}
		public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor() {
			return argumentsAnchor_;
		}
		public final org.ffd2.bones.base.BParameters getParametersAnchor() {
			return parametersAnchor_;
		}
		public final DesignFormHolder.DesignFormBlock.ChainDataBlock getChainEnd() {
			return chainEnd_;
		}
		public final DesignFormHolder.DesignFormBlock.ChainDataBlock addChain(ChainBlockFormHolder.ChainBlockFormBlock relatedChain, IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock chainID, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock chainTarget) {
			DesignFormHolder.DesignFormBlock.ChainDataBlock child = new DesignFormHolder.DesignFormBlock.ChainDataBlock(this, relatedChain, chainID, chainTarget, chainEnd_);
			chainEnd_ = child;
			return child;
		}
		public final DesignFormHolder.DesignFormBlock.TemplateDataBlock getTemplateEnd() {
			return templateEnd_;
		}
		public final DesignFormHolder.DesignFormBlock.TemplateDataBlock addTemplate(java.lang.String name, TemplateBlockFormHolder.TemplateBlockFormBlock template) {
			DesignFormHolder.DesignFormBlock.TemplateDataBlock child = new DesignFormHolder.DesignFormBlock.TemplateDataBlock(this, name, template, templateEnd_);
			templateEnd_ = child;
			return child;
		}
		public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParameter2End() {
			return parameter2End_;
		}
		public final java.lang.String getNameParameter() {
			return nameParameter_;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock getRelatedTrackerParameter() {
			return relatedTrackerParameter_;
		}
		public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getParametersParameter() {
			return parametersParameter_;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getTargetPeerParameter() {
			return targetPeerParameter_;
		}
		public final DataBlockFormHolder.DataBlockFormBlock getRootBlockDetailsParameter() {
			return rootBlockDetailsParameter_;
		}
		public final org.ffd2.bones.base.BClass getDesignRootBonesClass() {
			return designRootBonesClass_;
		}
		public final org.ffd2.bones.base.InstanceVariable getBaseBlocks_BonesVariable() {
			return baseBlocks_Bones_;
		}
		public final org.ffd2.bones.base.InstanceVariable getIdTracker_BonesVariable() {
			return idTracker_Bones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getResultBonesVariable() {
			return resultBones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getNumberOfBlocksBonesVariable() {
			return numberOfBlocksBones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getBuildIndexBonesVariable() {
			return buildIndexBones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getFinaliseIndexBonesVariable() {
			return finaliseIndexBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getIdTrackerBonesVariable() {
			return idTrackerBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getInitialDoOutputBonesVariable() {
			return initialDoOutputBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getNamespaceElementsBonesVariable() {
			return namespaceElementsBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getTargetBonesVariable() {
			return targetBones_;
		}
		public final org.ffd2.bones.base.BCodeBlock getConstructorCode() {
			return constructorCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getConstructorCode_1() {
			return constructorCode__1_;
		}
		public final org.ffd2.bones.base.BCodeBlock getConstructSimpleCode() {
			return constructSimpleCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getAddDataBlockCode() {
			return addDataBlockCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getBuildCode() {
			return buildCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getBuildCode_1() {
			return buildCode__1_;
		}
		public final org.ffd2.bones.base.BCodeBlock getBuildCode_2() {
			return buildCode__2_;
		}
		public final org.ffd2.bones.base.BMethod getConstructSimpleBonesMethod() {
			return constructSimpleMethod_;
		}
		public final org.ffd2.bones.base.BMethod getAddDataBlockBonesMethod() {
			return addDataBlockMethod_;
		}
		public final org.ffd2.bones.base.BMethod getBuildBonesMethod() {
			return buildMethod_;
		}
		private final void buildFor(org.ffd2.bones.base.BCodeBlock target) {
			org.ffd2.bones.base.BCodeBlock sub = target.createSubBlock();
			org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
			chain.chainVariable(this.getBaseBlocks_BonesVariable());
			expressionValue.callChain(chain);
			org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("get");
			org.ffd2.bones.base.BExpression argument = methodArguments.addNewArgument();
			argument.variable(this.getBuildIndexBonesVariable());
			expressionValue.callChain(chain_1);
			org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.MethodCall methodCall = chain_2.chainMethod(getRootBlockDetailsParameter().getInitiateTargetPeerBonesMethod());
			org.ffd2.bones.base.ArgumentSet methodArguments_1 = methodCall.getArguments();
			org.ffd2.bones.base.BExpression argument_1 = methodArguments_1.addNewArgument();
			argument_1.variable(this.getTargetBonesVariable());
			expressionValue.callChain(chain_2);
			sub.addExpression(expressionValue);
		}
		private final void buildFor_1(org.ffd2.bones.base.BCodeBlock target) {
			org.ffd2.bones.base.BCodeBlock sub = target.createSubBlock();
			org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
			chain.chainVariable(this.getBaseBlocks_BonesVariable());
			expressionValue.callChain(chain);
			org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("get");
			org.ffd2.bones.base.BExpression argument = methodArguments.addNewArgument();
			argument.variable(this.getFinaliseIndexBonesVariable());
			expressionValue.callChain(chain_1);
			org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.MethodCall methodCall = chain_2.chainMethod(getRootBlockDetailsParameter().getFinaliseTargetPeerBonesMethod());
			org.ffd2.bones.base.ArgumentSet methodArguments_1 = methodCall.getArguments();
			org.ffd2.bones.base.BExpression argument_1 = methodArguments_1.addNewArgument();
			argument_1.variable(this.getTargetBonesVariable());
			expressionValue.callChain(chain_2);
			sub.addExpression(expressionValue);
		}
		public final org.ffd2.bones.base.BClassStore getInlineAnchor() {
			return inlineContainerAnchor_;
		}
		public static final class ChainDataBlock {
			private final DesignFormHolder.DesignFormBlock.ChainDataBlock previous_;
			public DesignFormHolder.DesignFormBlock parent_;
			private final ChainBlockFormHolder.ChainBlockFormBlock relatedChainParameter_;
			private final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock chainIDParameter_;
			private final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock chainTargetParameter_;
			private org.ffd2.bones.base.InstanceVariable chains_Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration newChainBones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration idHack1Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration chainCount1Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration targetHack1Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration idHack2Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration chainCount2Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration chainIndex2Bones_;
			private final org.ffd2.bones.base.LocalVariableDeclaration singleChain2Bones_;
			private final org.ffd2.bones.base.BCodeBlock newChainCode_;
			private org.ffd2.bones.base.BMethod newChainMethod_;
			public ChainDataBlock(DesignFormHolder.DesignFormBlock parent, ChainBlockFormHolder.ChainBlockFormBlock relatedChain, IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock chainID, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock chainTarget, DesignFormHolder.DesignFormBlock.ChainDataBlock previous) {
				previous_ = previous;
				relatedChainParameter_ = relatedChain;
				chainIDParameter_ = chainID;
				chainTargetParameter_ = chainTarget;
				parent_ = parent;
				chains_Bones_ = new org.ffd2.bones.base.InstanceVariable();
				newChainBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				idHack1Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				chainCount1Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				targetHack1Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				idHack2Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				chainCount2Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				chainIndex2Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				singleChain2Bones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
				newChainCode_ = new org.ffd2.bones.base.BCodeBlock();
				newChainMethod_ = new org.ffd2.bones.base.BMethod();
				newChainMethod_.setCodeBlock(getNewChainCode());
			}
			public final DesignFormHolder.DesignFormBlock.ChainDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				getParent().getDesignRootBonesClass().addInstanceVariable(chains_Bones_);
				chains_Bones_.setName(getRelatedChainParameter().getChainNameParameter(), "Chains_");
				getParent().getDesignRootBonesClass().addInstanceMethod(newChainMethod_);
				org.ffd2.bones.base.BParameters parameters = newChainMethod_.getParameters();
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				newChainBones_.setName("newChain");
				org.ffd2.bones.base.TypeSettable varableType = newChainBones_.getTypeSettable();
				varableType.setResultType(getRelatedChainParameter().getChainBlockClassBonesClass());
				idHack1Bones_.setName("idHack1");
				org.ffd2.bones.base.TypeSettable varableType_1 = idHack1Bones_.getTypeSettable();
				varableType_1.setResultType(getChainIDParameter().getParent().getIDTrackerBonesClass());
				chainCount1Bones_.setName("chainCount1");
				org.ffd2.bones.base.TypeSettable varableType_2 = chainCount1Bones_.getTypeSettable();
				varableType_2.setIntResultType();
				targetHack1Bones_.setName("targetHack1");
				org.ffd2.bones.base.TypeSettable varableType_3 = targetHack1Bones_.getTypeSettable();
				varableType_3.setResultType(getChainTargetParameter().getParent().getTargetBaseBonesClass());
				idHack2Bones_.setName("idHack2");
				org.ffd2.bones.base.TypeSettable varableType_4 = idHack2Bones_.getTypeSettable();
				varableType_4.setResultType(getChainIDParameter().getParent().getIDTrackerBonesClass());
				chainCount2Bones_.setName("chainCount2");
				org.ffd2.bones.base.TypeSettable varableType_5 = chainCount2Bones_.getTypeSettable();
				varableType_5.setIntResultType();
				chainIndex2Bones_.setName("chainIndex2");
				org.ffd2.bones.base.TypeSettable varableType_6 = chainIndex2Bones_.getTypeSettable();
				varableType_6.setIntResultType();
				singleChain2Bones_.setName("singleChain2");
				org.ffd2.bones.base.TypeSettable varableType_7 = singleChain2Bones_.getTypeSettable();
				varableType_7.setResultType(getRelatedChainParameter().getChainBlockClassBonesClass());
				newChainMethod_.setName("newChain", getRelatedChainParameter().getChainNameParameter());
				org.ffd2.bones.base.TypeSettable returnType = newChainMethod_.getReturnTypeSettable();
				returnType.setResultType(getRelatedChainParameter().getChainBlockClassBonesClass());
				org.ffd2.bones.base.TypeSettable varableType_8 = chains_Bones_.getTypeSettable();
				varableType_8.setExternalType("org.ffd2.solar.general.SimpleVector");
				org.ffd2.bones.base.TypeSettable genericTarget = varableType_8.addGenerics();
				genericTarget.setResultType(getRelatedChainParameter().getChainBlockClassBonesClass());
				org.ffd2.bones.base.BCodeBlock target = getNewChainCode();
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable = this.getNewChainBonesVariable();
				target.addDeclareVariable(declarationVariable);
				org.ffd2.bones.base.BExpression initialValueExpression = declarationVariable.createValue();
				org.ffd2.bones.base.BConstructorCall constructorCall = initialValueExpression.constructorCall();
				org.ffd2.bones.base.TypeSettable targetType = constructorCall.getTypeSettable();
				targetType.setResultType(getRelatedChainParameter().getChainBlockClassBonesClass());
				org.ffd2.bones.base.ArgumentSet constructorArguments = constructorCall.getArgumentSet();
				org.ffd2.bones.base.BExpression argument = constructorArguments.addNewArgument();
				argument.variable(getParent().getIdTracker_BonesVariable());
				org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
				chain.chainVariable(this.getChains_BonesVariable());
				expressionValue.callChain(chain);
				org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("addElement");
				org.ffd2.bones.base.BExpression argument_1 = methodArguments.addNewArgument();
				argument_1.variable(this.getNewChainBonesVariable());
				expressionValue.callChain(chain_1);
				target.addExpression(expressionValue);
				org.ffd2.bones.base.BExpression returnValue = new org.ffd2.bones.base.BExpression();
				returnValue.variable(this.getNewChainBonesVariable());
				target.addReturn(returnValue);
				org.ffd2.bones.base.BCodeBlock localCode = getParent().getConstructorCode_1().anchor();
				org.ffd2.bones.base.BExpression expressionValue_1 = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression right = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression left = new org.ffd2.bones.base.BExpression();
				left.variable(this.getChains_BonesVariable());
				org.ffd2.bones.base.BConstructorCall constructorCall_1 = right.constructorCall();
				org.ffd2.bones.base.TypeSettable targetType_1 = constructorCall_1.getTypeSettable();
				targetType_1.setExternalType("org.ffd2.solar.general.SimpleVector");
				org.ffd2.bones.base.TypeSettable genericTarget_1 = targetType_1.addGenerics();
				genericTarget_1.setResultType(getRelatedChainParameter().getChainBlockClassBonesClass());
				expressionValue_1.binary(left, "=", right);
				localCode.addExpression(expressionValue_1);
				org.ffd2.bones.base.BCodeBlock localCode_1 = getParent().getBuildCode_1().anchor();
				org.ffd2.bones.base.BCodeBlock sub = localCode_1.createSubBlock();
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_1 = this.getIdHack1BonesVariable();
				sub.addDeclareVariable(declarationVariable_1);
				org.ffd2.bones.base.BExpression initialValueExpression_1 = declarationVariable_1.createValue();
				initialValueExpression_1.variable(getParent().getIdTracker_BonesVariable());
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_2 = this.getChainCount1BonesVariable();
				sub.addDeclareVariable(declarationVariable_2);
				org.ffd2.bones.base.BExpression initialValueExpression_2 = declarationVariable_2.createValue();
				org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
				chain_2.chainVariable(this.getIdHack1BonesVariable());
				initialValueExpression_2.callChain(chain_2);
				org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.MethodCall methodCall = chain_3.chainMethod(getChainIDParameter().getGetChainCountBonesMethod());
				initialValueExpression_2.callChain(chain_3);
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_3 = this.getTargetHack1BonesVariable();
				sub.addDeclareVariable(declarationVariable_3);
				org.ffd2.bones.base.BExpression initialValueExpression_3 = declarationVariable_3.createValue();
				initialValueExpression_3.variable(getParent().getTargetBonesVariable());
				org.ffd2.bones.base.BExpression expressionValue_2 = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.CallChain chain_4 = new org.ffd2.bones.base.CallChain();
				chain_4.chainVariable(this.getTargetHack1BonesVariable());
				expressionValue_2.callChain(chain_4);
				org.ffd2.bones.base.CallChain chain_5 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.MethodCall methodCall_1 = chain_5.chainMethod(getChainTargetParameter().getCreateChainsBonesMethod());
				org.ffd2.bones.base.ArgumentSet methodArguments_1 = methodCall_1.getArguments();
				org.ffd2.bones.base.BExpression argument_2 = methodArguments_1.addNewArgument();
				argument_2.variable(this.getChainCount1BonesVariable());
				expressionValue_2.callChain(chain_5);
				sub.addExpression(expressionValue_2);
				org.ffd2.bones.base.BCodeBlock localCode_2 = getParent().getBuildCode_2().anchor();
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_4 = this.getIdHack2BonesVariable();
				localCode_2.addDeclareVariable(declarationVariable_4);
				org.ffd2.bones.base.BExpression initialValueExpression_4 = declarationVariable_4.createValue();
				initialValueExpression_4.variable(getParent().getIdTracker_BonesVariable());
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_5 = this.getChainCount2BonesVariable();
				localCode_2.addDeclareVariable(declarationVariable_5);
				org.ffd2.bones.base.BExpression initialValueExpression_5 = declarationVariable_5.createValue();
				org.ffd2.bones.base.CallChain chain_6 = new org.ffd2.bones.base.CallChain();
				chain_6.chainVariable(this.getIdHack2BonesVariable());
				initialValueExpression_5.callChain(chain_6);
				org.ffd2.bones.base.CallChain chain_7 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.MethodCall methodCall_2 = chain_7.chainMethod(getChainIDParameter().getGetChainCountBonesMethod());
				initialValueExpression_5.callChain(chain_7);
				org.ffd2.bones.base.ForBlock forBlock = localCode_2.forBlock();
				org.ffd2.bones.base.BExpression conditionalExpression = forBlock.getTerminateConditional();
				org.ffd2.bones.base.BExpression roundExpression = forBlock.getLoopConditional();
				org.ffd2.bones.base.BExpression right_1 = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression left_1 = new org.ffd2.bones.base.BExpression();
				left_1.variable(this.getChainIndex2BonesVariable());
				right_1.variable(this.getChainCount2BonesVariable());
				conditionalExpression.binary(left_1, "<", right_1);
				org.ffd2.bones.base.BExpression unary = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression unary_1 = new org.ffd2.bones.base.BExpression();
				unary_1.variable(this.getChainIndex2BonesVariable());
				unary.postUnary(unary_1, "+");
				roundExpression.postUnary(unary, "+");
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_6 = this.getChainIndex2BonesVariable();
				forBlock.addInitialVariable(declarationVariable_6);
				org.ffd2.bones.base.BExpression initialValueExpression_6 = declarationVariable_6.createValue();
				initialValueExpression_6.primitiveInt(0);
				org.ffd2.bones.base.BCodeBlock loopBlock = forBlock.getMainCode();
				buildFor(loopBlock);
			}
			public final DesignFormHolder.DesignFormBlock getParent() {
				return parent_;
			}
			public final ChainBlockFormHolder.ChainBlockFormBlock getRelatedChainParameter() {
				return relatedChainParameter_;
			}
			public final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock getChainIDParameter() {
				return chainIDParameter_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock getChainTargetParameter() {
				return chainTargetParameter_;
			}
			public final org.ffd2.bones.base.InstanceVariable getChains_BonesVariable() {
				return chains_Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getNewChainBonesVariable() {
				return newChainBones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getIdHack1BonesVariable() {
				return idHack1Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getChainCount1BonesVariable() {
				return chainCount1Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getTargetHack1BonesVariable() {
				return targetHack1Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getIdHack2BonesVariable() {
				return idHack2Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getChainCount2BonesVariable() {
				return chainCount2Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getChainIndex2BonesVariable() {
				return chainIndex2Bones_;
			}
			public final org.ffd2.bones.base.LocalVariableDeclaration getSingleChain2BonesVariable() {
				return singleChain2Bones_;
			}
			public final org.ffd2.bones.base.BCodeBlock getNewChainCode() {
				return newChainCode_;
			}
			public final org.ffd2.bones.base.BMethod getNewChainBonesMethod() {
				return newChainMethod_;
			}
			private final void buildFor(org.ffd2.bones.base.BCodeBlock target) {
				org.ffd2.bones.base.BCodeBlock sub = target.createSubBlock();
				org.ffd2.bones.base.LocalVariableDeclaration declarationVariable = this.getSingleChain2BonesVariable();
				sub.addDeclareVariable(declarationVariable);
				org.ffd2.bones.base.BExpression initialValueExpression = declarationVariable.createValue();
				org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
				chain.chainVariable(this.getChains_BonesVariable());
				initialValueExpression.callChain(chain);
				org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("get");
				org.ffd2.bones.base.BExpression argument = methodArguments.addNewArgument();
				argument.variable(this.getChainIndex2BonesVariable());
				initialValueExpression.callChain(chain_1);
				org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
				chain_2.chainVariable(this.getSingleChain2BonesVariable());
				expressionValue.callChain(chain_2);
				org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.MethodCall methodCall = chain_3.chainMethod(getRelatedChainParameter().getUpdatePeerBonesMethod());
				org.ffd2.bones.base.ArgumentSet methodArguments_1 = methodCall.getArguments();
				org.ffd2.bones.base.BExpression argument_1 = methodArguments_1.addNewArgument();
				argument_1.variable(getParent().getTargetBonesVariable());
				expressionValue.callChain(chain_3);
				sub.addExpression(expressionValue);
			}
		}
		public static final class TemplateDataBlock {
			private final DesignFormHolder.DesignFormBlock.TemplateDataBlock previous_;
			public DesignFormHolder.DesignFormBlock parent_;
			private BaseBuilder.TemplateBuilderMacroBlock templateBuilderMacroInstance_;
			private final java.lang.String nameParameter_;
			private final TemplateBlockFormHolder.TemplateBlockFormBlock templateParameter_;
			private final org.ffd2.bones.base.BClassStore inlineContainerAnchor_;
			public TemplateDataBlock(DesignFormHolder.DesignFormBlock parent, java.lang.String name, TemplateBlockFormHolder.TemplateBlockFormBlock template, DesignFormHolder.DesignFormBlock.TemplateDataBlock previous) {
				previous_ = previous;
				inlineContainerAnchor_ = new org.ffd2.bones.base.BClassStore();
				nameParameter_ = name;
				templateParameter_ = template;
				parent_ = parent;
				templateBuilderMacroInstance_ = getParent().getParent().createTemplateBuilderMacro(this.getInlineAnchor(), this.getTemplateParameter());
			}
			public final DesignFormHolder.DesignFormBlock.TemplateDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				templateBuilderMacroInstance_.resolutionPass(packageAccess);
				packageAccess.addClassStore(inlineContainerAnchor_);
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				templateBuilderMacroInstance_.finish();
			}
			public final DesignFormHolder.DesignFormBlock getParent() {
				return parent_;
			}
			public final BaseBuilder.TemplateBuilderMacroBlock getTemplateBuilderMacroInstance() {
				return templateBuilderMacroInstance_;
			}
			public final java.lang.String getNameParameter() {
				return nameParameter_;
			}
			public final TemplateBlockFormHolder.TemplateBlockFormBlock getTemplateParameter() {
				return templateParameter_;
			}
			public final org.ffd2.bones.base.BClassStore getInlineAnchor() {
				return inlineContainerAnchor_;
			}
		}
		public static final class Parameter2DataBlock {
			private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock previous_;
			public DesignFormHolder.DesignFormBlock parent_;
			private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock peer_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__1_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__2_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__3_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__4_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__5_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__6_;
			private final org.ffd2.bones.base.ArgumentSet argumentsAnchor__7_;
			private final org.ffd2.bones.base.BParameters parametersAnchor_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__1_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__2_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__3_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__4_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__5_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__6_;
			private final org.ffd2.bones.base.BParameters parametersAnchor__7_;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Int3DataBlock int3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.IntArray3DataBlock intArray3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Boolean3DataBlock boolean3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Double3DataBlock double3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.String3DataBlock string3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock record3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Mapping3DataBlock mapping3End_ = null;
			public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Key3DataBlock key3End_ = null;
			public Parameter2DataBlock(DesignFormHolder.DesignFormBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock peer) {
				parent_ = parent;
				peer_ = peer;
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock previousPeer = peer.getPrevious();
				if(previousPeer == null) {
					previous_ = null;
				} else {
					previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock(parent, previousPeer);
				}
				argumentsAnchor_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__1_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__2_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__3_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__4_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__5_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__6_ = new org.ffd2.bones.base.ArgumentSet();
				argumentsAnchor__7_ = new org.ffd2.bones.base.ArgumentSet();
				parametersAnchor_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__1_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__2_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__3_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__4_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__5_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__6_ = new org.ffd2.bones.base.BParameters();
				parametersAnchor__7_ = new org.ffd2.bones.base.BParameters();
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock peerEnd = getPeer().getIntEnd();
				if(peerEnd != null) {
					int3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Int3DataBlock(this, peerEnd);
					int3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock peerEnd_1 = getPeer().getIntArrayEnd();
				if(peerEnd_1 != null) {
					intArray3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.IntArray3DataBlock(this, peerEnd_1);
					intArray3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock peerEnd_2 = getPeer().getBooleanEnd();
				if(peerEnd_2 != null) {
					boolean3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Boolean3DataBlock(this, peerEnd_2);
					boolean3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock peerEnd_3 = getPeer().getDoubleEnd();
				if(peerEnd_3 != null) {
					double3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Double3DataBlock(this, peerEnd_3);
					double3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock peerEnd_4 = getPeer().getStringEnd();
				if(peerEnd_4 != null) {
					string3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.String3DataBlock(this, peerEnd_4);
					string3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock peerEnd_5 = getPeer().getRecordEnd();
				if(peerEnd_5 != null) {
					record3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock(this, peerEnd_5);
					record3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock peerEnd_6 = getPeer().getMappingEnd();
				if(peerEnd_6 != null) {
					mapping3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Mapping3DataBlock(this, peerEnd_6);
					mapping3End_.resolutionPass(packageAccess);
				}
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock peerEnd_7 = getPeer().getKeyEnd();
				if(peerEnd_7 != null) {
					key3End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Key3DataBlock(this, peerEnd_7);
					key3End_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor();
				arguments.anchor(this.getArgumentsAnchor());
				arguments.anchor(this.getArgumentsAnchor_1());
				arguments.anchor(this.getArgumentsAnchor_2());
				arguments.anchor(this.getArgumentsAnchor_3());
				arguments.anchor(this.getArgumentsAnchor_4());
				arguments.anchor(this.getArgumentsAnchor_5());
				arguments.anchor(this.getArgumentsAnchor_6());
				arguments.anchor(this.getArgumentsAnchor_7());
				org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor();
				parameters.setAnchor(this.getParametersAnchor());
				parameters.setAnchor(this.getParametersAnchor_1());
				parameters.setAnchor(this.getParametersAnchor_2());
				parameters.setAnchor(this.getParametersAnchor_3());
				parameters.setAnchor(this.getParametersAnchor_4());
				parameters.setAnchor(this.getParametersAnchor_5());
				parameters.setAnchor(this.getParametersAnchor_6());
				parameters.setAnchor(this.getParametersAnchor_7());
				if(int3End_ != null) {
					int3End_.finish();
				}
				if(intArray3End_ != null) {
					intArray3End_.finish();
				}
				if(boolean3End_ != null) {
					boolean3End_.finish();
				}
				if(double3End_ != null) {
					double3End_.finish();
				}
				if(string3End_ != null) {
					string3End_.finish();
				}
				if(record3End_ != null) {
					record3End_.finish();
				}
				if(mapping3End_ != null) {
					mapping3End_.finish();
				}
				if(key3End_ != null) {
					key3End_.finish();
				}
			}
			public final DesignFormHolder.DesignFormBlock getParent() {
				return parent_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getPeer() {
				return peer_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor() {
				return argumentsAnchor_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_1() {
				return argumentsAnchor__1_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_2() {
				return argumentsAnchor__2_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_3() {
				return argumentsAnchor__3_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_4() {
				return argumentsAnchor__4_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_5() {
				return argumentsAnchor__5_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_6() {
				return argumentsAnchor__6_;
			}
			public final org.ffd2.bones.base.ArgumentSet getArgumentsAnchor_7() {
				return argumentsAnchor__7_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor() {
				return parametersAnchor_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_1() {
				return parametersAnchor__1_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_2() {
				return parametersAnchor__2_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_3() {
				return parametersAnchor__3_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_4() {
				return parametersAnchor__4_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_5() {
				return parametersAnchor__5_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_6() {
				return parametersAnchor__6_;
			}
			public final org.ffd2.bones.base.BParameters getParametersAnchor_7() {
				return parametersAnchor__7_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Int3DataBlock getInt3End() {
				return int3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.IntArray3DataBlock getIntArray3End() {
				return intArray3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Boolean3DataBlock getBoolean3End() {
				return boolean3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Double3DataBlock getDouble3End() {
				return double3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.String3DataBlock getString3End() {
				return string3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock getRecord3End() {
				return record3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Mapping3DataBlock getMapping3End() {
				return mapping3End_;
			}
			public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Key3DataBlock getKey3End() {
				return key3End_;
			}
			public static final class Int3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Int3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public Int3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Int3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Int3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setIntResultType();
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
			public static final class IntArray3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.IntArray3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public IntArray3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.IntArray3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.IntArray3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setIntResultType();
					varableType.setArrayDimensions(1);
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor_2();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_1();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
			public static final class Boolean3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Boolean3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public Boolean3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Boolean3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Boolean3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setBooleanResultType();
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor_4();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_2();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
			public static final class Double3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Double3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public Double3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Double3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Double3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setDoubleResultType();
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor_1();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_3();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
			public static final class String3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.String3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public String3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.String3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.String3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setExternalType("java.lang.String");
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor_3();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_4();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
			public static final class Record3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock peer_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock.IsParameter4DataBlock isParameter4End_ = null;
				public Record3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock(parent, previousPeer);
					}
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock peerEnd = getPeer().getIsParameterEnd();
					if(peerEnd != null) {
						isParameter4End_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock.IsParameter4DataBlock(this, peerEnd);
						isParameter4End_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					if(isParameter4End_ != null) {
						isParameter4End_.finish();
					}
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getPeer() {
					return peer_;
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock.IsParameter4DataBlock getIsParameter4End() {
					return isParameter4End_;
				}
				public static final class IsParameter4DataBlock {
					private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock.IsParameter4DataBlock previous_;
					public DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock parent_;
					private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock peer_;
					private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
					public IsParameter4DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock peer) {
						parent_ = parent;
						peer_ = peer;
						ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock previousPeer = peer.getPrevious();
						if(previousPeer == null) {
							previous_ = null;
						} else {
							previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock.IsParameter4DataBlock(parent, previousPeer);
						}
						parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
					}
					public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock.IsParameter4DataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
						parameterValueBones_.setName(getPeer().getParent().getParent().getParameterNameParameter(), "Value");
						org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
						varableType.setResultType(getPeer().getParent().getBlockParameter().getDataClassBonesClass());
						org.ffd2.bones.base.ArgumentSet arguments = getParent().getParent().getArgumentsAnchor_5();
						org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
						argument.variable(this.getParameterValueBonesVariable());
						org.ffd2.bones.base.BParameters parameters = getParent().getParent().getParametersAnchor_5();
						parameters.addParameter(getParameterValueBonesVariable());
					}
					public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Record3DataBlock getParent() {
						return parent_;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock getPeer() {
						return peer_;
					}
					public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
						return parameterValueBones_;
					}
				}
			}
			public static final class Mapping3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Mapping3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public Mapping3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Mapping3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Mapping3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setResultType(getPeer().getMappingParameter().getMappingInterfaceBonesClass());
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor_6();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_6();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
			public static final class Key3DataBlock {
				private final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Key3DataBlock previous_;
				public DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent_;
				private ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock peer_;
				private final org.ffd2.bones.base.ParameterVariable parameterValueBones_;
				public Key3DataBlock(DesignFormHolder.DesignFormBlock.Parameter2DataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock peer) {
					parent_ = parent;
					peer_ = peer;
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock previousPeer = peer.getPrevious();
					if(previousPeer == null) {
						previous_ = null;
					} else {
						previous_ = new DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Key3DataBlock(parent, previousPeer);
					}
					parameterValueBones_ = new org.ffd2.bones.base.ParameterVariable();
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock.Key3DataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					parameterValueBones_.setName(getPeer().getParent().getParameterNameParameter(), "Value");
					org.ffd2.bones.base.TypeSettable varableType = parameterValueBones_.getTypeSettable();
					varableType.setResultType(getPeer().getKeyParameter().getKeyMarkerInterfaceBonesClass());
					org.ffd2.bones.base.ArgumentSet arguments = getParent().getArgumentsAnchor_7();
					org.ffd2.bones.base.BExpression argument = arguments.addNewArgument();
					argument.variable(this.getParameterValueBonesVariable());
					org.ffd2.bones.base.BParameters parameters = getParent().getParametersAnchor_7();
					parameters.addParameter(getParameterValueBonesVariable());
				}
				public final DesignFormHolder.DesignFormBlock.Parameter2DataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock getPeer() {
					return peer_;
				}
				public final org.ffd2.bones.base.ParameterVariable getParameterValueBonesVariable() {
					return parameterValueBones_;
				}
			}
		}
	}
}
