package org.ffd2.skeletonx.skeleton;
public final class JavaParameterSettingsFormHolder {
	public static final class JavaParameterSettingsFormBlock {
		private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock previous_;
		public BaseBuilder parent_;
		public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parameterEnd_ = null;
		public JavaParameterSettingsFormBlock(BaseBuilder parent, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock previous) {
			previous_ = previous;
			parent_ = parent;
		}
		public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(parameterEnd_ != null) {
				parameterEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(parameterEnd_ != null) {
				parameterEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParameterEnd() {
			return parameterEnd_;
		}
		public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock addParameter(java.lang.String parameterName) {
			JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock(this, parameterName, parameterEnd_);
			parameterEnd_ = child;
			return child;
		}
		public static final class ParameterDataBlock {
			private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock previous_;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock parent_;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock intEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock intArrayEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock stringEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock booleanEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock doubleEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock recordEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock generalRecordEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock chainRecordEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock mappingEnd_ = null;
			public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock keyEnd_ = null;
			private final java.lang.String parameterNameParameter_;
			public ParameterDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock parent, java.lang.String parameterName, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock previous) {
				previous_ = previous;
				parameterNameParameter_ = parameterName;
				parent_ = parent;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(intEnd_ != null) {
					intEnd_.resolutionPass(packageAccess);
				}
				if(intArrayEnd_ != null) {
					intArrayEnd_.resolutionPass(packageAccess);
				}
				if(stringEnd_ != null) {
					stringEnd_.resolutionPass(packageAccess);
				}
				if(booleanEnd_ != null) {
					booleanEnd_.resolutionPass(packageAccess);
				}
				if(doubleEnd_ != null) {
					doubleEnd_.resolutionPass(packageAccess);
				}
				if(recordEnd_ != null) {
					recordEnd_.resolutionPass(packageAccess);
				}
				if(generalRecordEnd_ != null) {
					generalRecordEnd_.resolutionPass(packageAccess);
				}
				if(chainRecordEnd_ != null) {
					chainRecordEnd_.resolutionPass(packageAccess);
				}
				if(mappingEnd_ != null) {
					mappingEnd_.resolutionPass(packageAccess);
				}
				if(keyEnd_ != null) {
					keyEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(intEnd_ != null) {
					intEnd_.finish();
				}
				if(intArrayEnd_ != null) {
					intArrayEnd_.finish();
				}
				if(stringEnd_ != null) {
					stringEnd_.finish();
				}
				if(booleanEnd_ != null) {
					booleanEnd_.finish();
				}
				if(doubleEnd_ != null) {
					doubleEnd_.finish();
				}
				if(recordEnd_ != null) {
					recordEnd_.finish();
				}
				if(generalRecordEnd_ != null) {
					generalRecordEnd_.finish();
				}
				if(chainRecordEnd_ != null) {
					chainRecordEnd_.finish();
				}
				if(mappingEnd_ != null) {
					mappingEnd_.finish();
				}
				if(keyEnd_ != null) {
					keyEnd_.finish();
				}
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock getParent() {
				return parent_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getIntEnd() {
				return intEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock addInt(IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock variableStore) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock(this, variableStore, intEnd_);
				intEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getIntArrayEnd() {
				return intArrayEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock addIntArray(IntArrayBuilderVariableAccessFormHolder.IntArrayBuilderVariableAccessFormBlock variableStore) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock(this, variableStore, intArrayEnd_);
				intArrayEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getStringEnd() {
				return stringEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock addString(StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock variableStore) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock(this, variableStore, stringEnd_);
				stringEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getBooleanEnd() {
				return booleanEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock addBoolean(BooleanBuilderVariableAccessFormHolder.BooleanBuilderVariableAccessFormBlock variableStore) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock(this, variableStore, booleanEnd_);
				booleanEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getDoubleEnd() {
				return doubleEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock addDouble(DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock variableStore) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock(this, variableStore, doubleEnd_);
				doubleEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getRecordEnd() {
				return recordEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock addRecord(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock block) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock(this, block, recordEnd_);
				recordEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock getGeneralRecordEnd() {
				return generalRecordEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock addGeneralRecord(JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock block) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock(this, block, generalRecordEnd_);
				generalRecordEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock getChainRecordEnd() {
				return chainRecordEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock addChainRecord(JavaImplementationFormHolder.JavaImplementationFormBlock.ChainDataBlock chain) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock(this, chain, chainRecordEnd_);
				chainRecordEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getMappingEnd() {
				return mappingEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock addMapping(MappingBuilderFormHolder.MappingBuilderFormBlock mapping) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock(this, mapping, mappingEnd_);
				mappingEnd_ = child;
				return child;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock getKeyEnd() {
				return keyEnd_;
			}
			public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock addKey(KeyBuilderFormHolder.KeyBuilderFormBlock key) {
				JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock child = new JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock(this, key, keyEnd_);
				keyEnd_ = child;
				return child;
			}
			public final java.lang.String getParameterNameParameter() {
				return parameterNameParameter_;
			}
			public static final class IntDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock variableStoreParameter_;
				private org.ffd2.bones.base.BMethod getIntValueMethod_;
				public IntDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock variableStore, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock previous) {
					previous_ = previous;
					variableStoreParameter_ = variableStore;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock getVariableStoreParameter() {
					return variableStoreParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetIntValueBonesMethod() {
					return getIntValueMethod_;
				}
				public final void setGetIntValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getIntValueMethod_ = value;
				}
			}
			public static final class IntArrayDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final IntArrayBuilderVariableAccessFormHolder.IntArrayBuilderVariableAccessFormBlock variableStoreParameter_;
				private org.ffd2.bones.base.BMethod getIntArrayValueMethod_;
				public IntArrayDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, IntArrayBuilderVariableAccessFormHolder.IntArrayBuilderVariableAccessFormBlock variableStore, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock previous) {
					previous_ = previous;
					variableStoreParameter_ = variableStore;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final IntArrayBuilderVariableAccessFormHolder.IntArrayBuilderVariableAccessFormBlock getVariableStoreParameter() {
					return variableStoreParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetIntArrayValueBonesMethod() {
					return getIntArrayValueMethod_;
				}
				public final void setGetIntArrayValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getIntArrayValueMethod_ = value;
				}
			}
			public static final class StringDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock variableStoreParameter_;
				private org.ffd2.bones.base.BMethod getStringValueMethod_;
				public StringDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock variableStore, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock previous) {
					previous_ = previous;
					variableStoreParameter_ = variableStore;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock getVariableStoreParameter() {
					return variableStoreParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetStringValueBonesMethod() {
					return getStringValueMethod_;
				}
				public final void setGetStringValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getStringValueMethod_ = value;
				}
			}
			public static final class BooleanDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final BooleanBuilderVariableAccessFormHolder.BooleanBuilderVariableAccessFormBlock variableStoreParameter_;
				private org.ffd2.bones.base.BMethod getBooleanValueMethod_;
				public BooleanDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, BooleanBuilderVariableAccessFormHolder.BooleanBuilderVariableAccessFormBlock variableStore, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock previous) {
					previous_ = previous;
					variableStoreParameter_ = variableStore;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final BooleanBuilderVariableAccessFormHolder.BooleanBuilderVariableAccessFormBlock getVariableStoreParameter() {
					return variableStoreParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetBooleanValueBonesMethod() {
					return getBooleanValueMethod_;
				}
				public final void setGetBooleanValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getBooleanValueMethod_ = value;
				}
			}
			public static final class DoubleDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock variableStoreParameter_;
				private org.ffd2.bones.base.BMethod getDoubleValueMethod_;
				public DoubleDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock variableStore, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock previous) {
					previous_ = previous;
					variableStoreParameter_ = variableStore;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock getVariableStoreParameter() {
					return variableStoreParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetDoubleValueBonesMethod() {
					return getDoubleValueMethod_;
				}
				public final void setGetDoubleValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getDoubleValueMethod_ = value;
				}
			}
			public static final class RecordDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock previous_;
				private org.ffd2.bones.base.ChainLink blockVariableLink_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock blockParameter_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				private org.ffd2.bones.base.BMethod getRecordValueMethod_;
				private org.ffd2.bones.base.BMethod getRecordIndexMethod_;
				public RecordDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock block, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock previous) {
					previous_ = previous;
					blockParameter_ = block;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final void setConnection(org.ffd2.bones.base.ChainLink link) {
					blockVariableLink_ = link;
				}
				public final void addBlockVariableConnection(org.ffd2.bones.base.CallChain chain) {
					chain.chainLink(blockVariableLink_);
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.IsDesignLinkedDataBlock getBlockParameter() {
					return blockParameter_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
				public final org.ffd2.bones.base.BMethod getGetRecordValueBonesMethod() {
					return getRecordValueMethod_;
				}
				public final void setGetRecordValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getRecordValueMethod_ = value;
				}
				public final org.ffd2.bones.base.BMethod getGetRecordIndexBonesMethod() {
					return getRecordIndexMethod_;
				}
				public final void setGetRecordIndexBonesMethod(org.ffd2.bones.base.BMethod value) {
					getRecordIndexMethod_ = value;
				}
			}
			public static final class GeneralRecordDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock previous_;
				private org.ffd2.bones.base.ChainLink generalBlockVariableLink_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock blockParameter_;
				private org.ffd2.bones.base.BMethod getRecordValueMethod_;
				public GeneralRecordDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock block, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock previous) {
					previous_ = previous;
					blockParameter_ = block;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.GeneralRecordDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final void setConnection(org.ffd2.bones.base.ChainLink link) {
					generalBlockVariableLink_ = link;
				}
				public final void addGeneralBlockVariableConnection(org.ffd2.bones.base.CallChain chain) {
					chain.chainLink(generalBlockVariableLink_);
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock getBlockParameter() {
					return blockParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetRecordValueBonesMethod() {
					return getRecordValueMethod_;
				}
				public final void setGetRecordValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getRecordValueMethod_ = value;
				}
			}
			public static final class ChainRecordDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final JavaImplementationFormHolder.JavaImplementationFormBlock.ChainDataBlock chainParameter_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				private org.ffd2.bones.base.BMethod getBuiltChainMethod_;
				public ChainRecordDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, JavaImplementationFormHolder.JavaImplementationFormBlock.ChainDataBlock chain, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock previous) {
					previous_ = previous;
					chainParameter_ = chain;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.ChainRecordDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final JavaImplementationFormHolder.JavaImplementationFormBlock.ChainDataBlock getChainParameter() {
					return chainParameter_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
				public final org.ffd2.bones.base.BMethod getGetBuiltChainBonesMethod() {
					return getBuiltChainMethod_;
				}
				public final void setGetBuiltChainBonesMethod(org.ffd2.bones.base.BMethod value) {
					getBuiltChainMethod_ = value;
				}
			}
			public static final class MappingDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final MappingBuilderFormHolder.MappingBuilderFormBlock mappingParameter_;
				private org.ffd2.bones.base.BMethod getMappingValueMethod_;
				public MappingDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, MappingBuilderFormHolder.MappingBuilderFormBlock mapping, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock previous) {
					previous_ = previous;
					mappingParameter_ = mapping;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final MappingBuilderFormHolder.MappingBuilderFormBlock getMappingParameter() {
					return mappingParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetMappingValueBonesMethod() {
					return getMappingValueMethod_;
				}
				public final void setGetMappingValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getMappingValueMethod_ = value;
				}
			}
			public static final class KeyDataBlock {
				private final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock previous_;
				public JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final KeyBuilderFormHolder.KeyBuilderFormBlock keyParameter_;
				private org.ffd2.bones.base.BMethod getKeyValueMethod_;
				public KeyDataBlock(JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock parent, KeyBuilderFormHolder.KeyBuilderFormBlock key, JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock previous) {
					previous_ = previous;
					keyParameter_ = key;
					parent_ = parent;
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final KeyBuilderFormHolder.KeyBuilderFormBlock getKeyParameter() {
					return keyParameter_;
				}
				public final org.ffd2.bones.base.BMethod getGetKeyValueBonesMethod() {
					return getKeyValueMethod_;
				}
				public final void setGetKeyValueBonesMethod(org.ffd2.bones.base.BMethod value) {
					getKeyValueMethod_ = value;
				}
			}
		}
	}
}
