package org.ffd2.skeletonx.skeleton;
public final class MappingBuilderFormHolder {
	public static final class MappingBuilderFormBlock {
		private final MappingBuilderFormHolder.MappingBuilderFormBlock previous_;
		public BaseBuilder parent_;
		private final java.lang.String mappingNameParameter_;
		private final KeyBuilderFormHolder.KeyBuilderFormBlock keyTypeParameter_;
		private org.ffd2.bones.base.BClass mappingInterfaceBonesClass_;
		private final org.ffd2.bones.base.ParameterVariable keyBones_;
		private org.ffd2.bones.base.BMethod getMappingMethod_;
		public MappingBuilderFormBlock(BaseBuilder parent, java.lang.String mappingName, KeyBuilderFormHolder.KeyBuilderFormBlock keyType, MappingBuilderFormHolder.MappingBuilderFormBlock previous) {
			previous_ = previous;
			mappingNameParameter_ = mappingName;
			keyTypeParameter_ = keyType;
			parent_ = parent;
			mappingInterfaceBonesClass_ = new org.ffd2.bones.base.BClass(false);
			keyBones_ = new org.ffd2.bones.base.ParameterVariable();
			getMappingMethod_ = new org.ffd2.bones.base.BMethod();
		}
		public final MappingBuilderFormHolder.MappingBuilderFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			packageAccess.addType(mappingInterfaceBonesClass_);
			mappingInterfaceBonesClass_.setName(this.getMappingNameParameter(), "Mapping");
			this.getMappingInterfaceBonesClass().addInstanceMethod(getMappingMethod_);
			org.ffd2.bones.base.BParameters parameters = getMappingMethod_.getParameters();
			parameters.addParameter(getKeyBonesVariable());
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			keyBones_.setName("key");
			org.ffd2.bones.base.TypeSettable varableType = keyBones_.getTypeSettable();
			varableType.setResultType(getKeyTypeParameter().getKeyMarkerInterfaceBonesClass());
			getMappingMethod_.setName("get", this.getMappingNameParameter(), "Mapping");
			org.ffd2.bones.base.TypeSettable returnType = getMappingMethod_.getReturnTypeSettable();
			returnType.setIntResultType();
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final java.lang.String getMappingNameParameter() {
			return mappingNameParameter_;
		}
		public final KeyBuilderFormHolder.KeyBuilderFormBlock getKeyTypeParameter() {
			return keyTypeParameter_;
		}
		public final org.ffd2.bones.base.BClass getMappingInterfaceBonesClass() {
			return mappingInterfaceBonesClass_;
		}
		public final org.ffd2.bones.base.ParameterVariable getKeyBonesVariable() {
			return keyBones_;
		}
		public final org.ffd2.bones.base.BMethod getGetMappingBonesMethod() {
			return getMappingMethod_;
		}
	}
}
